package BbTree;
require CMONOS::Baobab::BbTrunk;
@ISA = qw(BbTrunk);
use strict;
######################################################################
# ХХֵĥ꡼ɽ⥸塼
# BbTree.pm ver1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-08-13
######################################################################
# ֥Ⱥ
sub new ($) {
my $pkg = shift;
my $this = {};
bless $this, $pkg;
return $this;
}

######################################################################
# ɬפʥեɤID֤
sub required_field ($) {
my $this = shift;
$setting::page{$setting::key}{'treeLimit'} = 30 if !$setting::page{$setting::key}{'treeLimit'} || $setting::page{$setting::key}{'treeLimit'} <= 0;

# ɽեɼ
foreach (sort {$a <=> $b} keys %field::ORDER) {
	my $id = $field::ORDER{$_};
	next unless ref $field::obj{$id} && !$field::obj{$id}->{'Hidden'} && $field::obj{$id}->{'tree'} && ($field::obj{$id}->{'class'} =~ /^xbb_/ || $field::obj{$id}->format_for_text_enabled) && ($field::obj{$id}->{'Open'} || $this->is_secure('secret'));
	next if grep($_ eq $id,@{$this->{'requiredField'}});
	push(@{$this->{'requiredField'}},$id);
	$field::obj{$id}->{'field_style_disabled'} = 2;
	$field::obj{$id}->{'field_tag_enabled'} = 'no';
}
return @{$this->{'requiredField'}};
}

######################################################################
# ڡåƥ
sub css ($) {
my $this = shift;
return '' if $setting::page{$setting::key}{'treeNoLine'};
return <<END;
ul.bb-tree, ul.bb-tree ul {
  background: transparent none;
  border: none;
  list-style: none;
  padding: 0;
  text-align: left;
  font-family: "ҥ饮γѥ Pro W3","ͣӡХå",sans-serif;
}
ul.bb-tree ul { margin: 0; }
ul.bb-tree li {
  background: transparent none;
  border: none;
  margin: 0;
  padding: 0;
  white-space: nowrap;
}
ul.bb-tree * { line-height: 97%; }
ul.bb-tree li span.bb-indent { font-size: 1.3em; }
ul.bb-tree li span.bb-list { font-size: 0.8em; }
ul.bb-tree li span.nobr:after {
  content: "";
  white-space: nowrap;
}
END
}

######################################################################
# 
sub list_count ($$$$$$$) {
my($this,$output,$database,$list,$p,$t,$n) = @_;
my($page,$e);
$p = 0 if !defined $p ||  !$p;
$this->{'count'} = $page = $e = 0;
$this->sub_list_count($output,$database,$n,$list,\$page,\$e);
return (!$output && $n) ? $page : $p;
}

sub sub_list_count ($$$$$$$) {
my($this,$output,$database,$n,$list,$page,$e) = @_;
my($no);
foreach $no (@$list) {
	if ($n && !$output && !$$e) {
		$$page++ if $this->{'count'} && $setting::page{$setting::key}{'treeLimit'} && $this->{'count'} % $setting::page{$setting::key}{'treeLimit'} == 0;
		$$e = 1 if $no eq $n;
	}
	$this->{'count'}++;
	my @child = split(/,/,$database->{'tree'}->{$no});
	splice(@child,0,3);
	$this->sub_list_count($output,$database,$n,\@child,$page,$e);
}
}

######################################################################
# إå
sub print_list_header ($$$$) {
my($this,$handle,$output,$p) = @_;

#ڡؤΥ
$this->print_page_jump_form($handle,$output,$p,$setting::page{$setting::key}{'treeLimit'},$this->{'count'});

#ĥ꡼ե졼
print $handle $this->frame_start(
	$setting::page{$setting::key}{'treeFrame'},
	'',
	'',
	'baobab-tree-frame',
	'',
	$output
) if defined $setting::page{$setting::key}{'treeFrame'} && $setting::page{$setting::key}{'treeFrame'} ne '';

}

######################################################################
#ꥹ
sub print_articles ($$$$$$;$$$) {
my($this,$handle,$output,$database,$list,$p,$t,$n,$whole) = @_;
if (!ref $list || !@$list) {
	print $handle 'åɤĤޤǤ';
	return;
}
my $query = $this->amp_escape($this->set_query('url+',(($output) ? ($default::subdivided) ? ['c'] : [] : \@setting::form1)));
my($count,$from,$to,$class,$style);
if (defined $setting::page{$setting::key}{'treeStyle'} && $setting::page{$setting::key}{'treeStyle'}) {
	if ($setting::page{$setting::key}{'treeStyle'} =~ /:/) {
		$style = $setting::page{$setting::key}{'treeStyle'};
	} else {
		$class = 'bb-tree ' . $setting::page{$setting::key}{'treeStyle'};
	}
} else {
	$class = 'bb-tree';
}
if ($whole) {
	$from = 0;
	$to = 9999;
} else {
	$from = $p * $setting::page{$setting::key}{'treeLimit'};
	$to = $from + $setting::page{$setting::key}{'treeLimit'};
}
if ($output) {
	undef $t;
	undef $n;
}
$count = 0;
$this->sub_print_articles($handle,$database,$list,\$from,\$to,\$count,'','<ul' . (($class) ? ' class="' . $this->escape($class) . '"' : '') . (($style) ? ' style="' . $this->escape($style) . '"' : '') . '>','</ul>',\$query,$t,$n);
}

sub pre_print_articles ($$) {
my($this,$output) = @_;
if (defined $output && $output) {
	return ($this->base_change($default::file,$output),'');
} else {
	my $query = $this->amp_escape($this->set_query('url+',\@setting::form1));
	return ($default::file,$query);
}
}

sub sub_print_articles ($$$$$$$$$) {
my($this,$handle,$database,$list,$from,$to,$count,$indent,$start,$end,$query,$thread_no,$article_no) = @_;
return if !@$list || $$count >= $$to;
my($trunk_count,$ul_done);
$trunk_count = 0;
foreach my $n (@$list) {
	last if $$count >= $$to;
	my @child = split(/,/,$database->{'tree'}->{$n});
	my $indent2 = '';
	my $is_listed = 0;
	if ($$count >= $$from) {
		print $handle $start if $start && !$ul_done;
		print $handle '<li>';
		if (!$setting::page{$setting::key}{'treeNoLine'}) {
			print $handle '<span class="bb-indent">';
			print $handle $indent;
			if (!defined $child[1] || $child[1] eq '' || $n eq $child[1]) {
				print $handle '';
				$indent2 = '';
			} elsif ($trunk_count < $#{$list}) {
				print $handle '';
				$indent2 = '';
			} else {
				print $handle '';
				$indent2 = '';
			}
			print $handle '</span><span class="bb-list">';
		}
		print $handle '<strong>' if $article_no && $article_no eq $n;
		$this->print_article_info($handle,$database,$n,$query);
		print $handle '</strong>' if $article_no && $article_no eq $n;
		print $handle '</span>' if !$setting::page{$setting::key}{'treeNoLine'};
		$is_listed = $ul_done = 1;
	} elsif (!$setting::page{$setting::key}{'treeNoLine'}) {
		if ($child[1] eq '' || $n eq $child[1]) {
			$indent2 = '';
		} elsif ($trunk_count < $#{$list}) {
			$indent2 = '';
		} else {
			$indent2 = '';
		}
	}
	$$count++;
	$trunk_count++;
	splice(@child,0,3);
	if (@child) {
		$this->sub_print_articles($handle,$database,\@child,$from,$to,$count,$indent . $indent2,(($is_listed) ? '' : $start . '<li>') . '<ul>','</ul>',$query,$thread_no,$article_no);
		$is_listed = $ul_done = 1 if $$count > $$from;
	}
	print $handle '</li>' if $is_listed;
}
print $handle $end if $ul_done;
}

sub print_article_info ($$$$$$) {
my($this,$handle,$database,$n,$query) = @_;
my $printed = 0;
foreach my $id (@{$this->{'requiredField'}}) {
	delete $field::obj{$id}->{'head'};
	delete $field::obj{$id}->{'foot'};
	print $handle ' ' if $printed;
	if ($id eq $field::for{'title'}) {
		print $handle '<a href="' . $cgi::path . '?m=Viewer&amp;k=viewer&amp;v=listarticle&amp;n=' . $n . $$query . '" name="n' . $n . '" id="n' . $n . '"';
		print $handle ' onclick="cmonos.element.item(this).fixTarget()"' if $main::k ne 'viewer';
		print $handle '>';
		if ($database->{'tree'}->{$n} =~ /^d/) {
			print $handle (($setting::page{'deletedMsg'}) ? $setting::page{'deletedMsg'} : '<em>' . (($database->{'tree'}->{$n} =~ /^dm/) ? '' : 'Ƽ') . 'ˤꡢεϺޤ</em>');
		} else {
			my($db,$title);
			$db = $field::obj{$id}->db;
			$title = $database->{$db}->{$n} if defined $db && $db;
			if (defined $title && $title ne '') {
				print $handle $this->jfold($this->detag($field::obj{$id}->format_for_text($title,$default::file . '/' . $n,$main::c,$n,$database)),50,'I',1);
			} else {
				print $handle (($setting::page{'defaultTitle'}) ? $setting::page{'defaultTitle'} : '(̵)');
			}
		}
		print $handle '</a>';
	} elsif ($field::obj{$id}->{'class'} =~ /^text/) {
		print $handle $this->jfold($this->detag($field::obj{$id}->format_for_text($database->{$field::obj{$id}->db}->{$n},$default::file . '/' . $n,$main::c,$n,$database)),50,'I',1);
	} elsif ($field::obj{$id}->{'class'} =~ /^xbb_/ || $field::obj{$id}->{'class'} =~ /xtime/) {
		my $db = $field::obj{$id}->db;
		print $handle $field::obj{$id}->usual_format((($db) ? $database->{$db}->{$n} : ''),$default::file . '/' . $n,$main::c,$n,$database);
	} elsif ($field::obj{$id}->{'class'} =~ /email/) {
		my $db = $field::obj{$id}->db;
		print $handle $this->escape($field::obj{$id}->format_for_text((($db) ? $database->{$db}->{$n} : ''),$default::file . '/' . $n,$main::c,$n,$database));
	} else {
		my $db = $field::obj{$id}->db;
		print $handle $this->detag($field::obj{$id}->format_for_text((($db) ? $database->{$db}->{$n} : ''),$default::file . '/' . $n,$main::c,$n,$database),2);
	}
	$printed = 1;
}
}

######################################################################
#
sub print_input_form ($$$$$$$$) {
my($this,$handle,$output,$database,$t,$n,$v) = @_;
return;
}

######################################################################
#եå
sub print_list_footer ($$$$) {
my($this,$handle,$output,$p) = @_;

#ơ֥ե졼ཪλ
print $handle $this->frame_end($setting::page{$setting::key}{'treeFrame'},'','','baobab-tree-frame',1) if defined $setting::page{$setting::key}{'treeFrame'} && $setting::page{$setting::key}{'treeFrame'} ne '';

#ڡؤΥ
$this->print_page_jump_form($handle,$output,$p,$setting::page{$setting::key}{'treeLimit'},$this->{'count'},'2');
}

1;
