package SimpleConsumer;
use strict;
######################################################################
# SimpleConsumer.pm ver0.9
# CMONOS::CGI_Lib::OpenID::SimpleConsumer.pm ver1.0
# Copyright (C) 2007-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-04-01
# 
######################################################################
# Thanks!http://lab.koshigoe.jp/en2ja/openid-authentication-2_0.html
######################################################################
# Ȥ
# require CMONOS::CGI_Lib::OpenID::SimpleConsumer;
# $consumer = SimpleConsumer->new({
#	'openid.realm'	=>	OpenID Realm,
# });
#
######################################################################
# ֥Ȥ롣
sub new ($;$) {
my($pkg,$params) = @_;
my $this = {'parameter' => {}};
if (ref $params) {
	while (my($k,$v) = each %$params) {
		$this->{'parameter'}->{$k} = $v;
	}
}
$this->{'parameter'}->{'openid.ns'} = 'http://specs.openid.net/auth/2.0';
bless $this;
return $this;
}

sub checkid_url ($$$$$$$$;$) {
my($this,$endpoint_url,$mode,$return_to,$claimed_id,$identity,$extention_hash) = @_;
if (!$endpoint_url) {
	$this->{'message'} = 'OpenID ץХߤĤޤ';
	return '';
} elsif ($endpoint_url !~ m!^https://!i) {
	$this->{'message'} = 'HTTPS ΤߤбƤޤ';
	return '';
} elsif (!$return_to) {
	$this->{'message'} = 'ERROR!';
	return '';
}
my $parameter_hash = {
	%{$this->{'parameter'}},
	'openid.mode'		=> (($mode) ? $mode : 'checkid_immediate'),
	'openid.return_to'	=> $return_to,
};
$parameter_hash->{'openid.claimed_id'} = ($claimed_id) ? $claimed_id : 'http://specs.openid.net/auth/2.0/identifier_select';
$parameter_hash->{'openid.identity'} = ($identity) ? $identity : 'http://specs.openid.net/auth/2.0/identifier_select';
if (defined $extention_hash && ref $extention_hash) {
	my $n;
	my %types;
	while (my($type,$param_hash) = each %$extention_hash) {
		my $ns = ($type =~ m!(\w+)/[\d\.]+$! && !$types{$1}++) ? $1 : 'ext' . $n++;
		$parameter_hash->{'openid.ns.' . $ns} = $type;
		while (my($k,$v) = each %$param_hash) {
			$parameter_hash->{'openid.' . $ns . '.' . $k} = $v;
		}
	}
}
return $endpoint_url . (($endpoint_url =~ /\?/) ? '&' : '?') . $this->query($parameter_hash);
}

sub get_return_to_url ($$) {
my($this,$return_to,$want_url) = @_;
my $rp_nonce = $this->make_nonce;
$return_to .= (($return_to =~ /\?/) ? '&' : '?') . 'rp_nonce=' . $rp_nonce;
return (wantarray && !$want_url) ? ($return_to,$rp_nonce) : $return_to;
}

sub discovery ($$) {
my($this,$url) = @_;
$url = $this->normalize($url);
require CMONOS::CGI_Lib::HTTP_Client;
my $res = HTTP_Client->new->request('GET' => $url);
if ($res->is_success) {
	my($endpoint_url,$xrds_url);
	$endpoint_url = $this->get_endpoint_url_from_xrds($res->hash) if $res->content_type eq 'application/xrds+xml';
	if (!$endpoint_url) {
		$xrds_url = $res->header('X-XRDS-Location');
		($endpoint_url,$xrds_url) = $this->get_endpoint_url_from_html($res->content) if !$xrds_url;
	}
	if ($endpoint_url) {
		return $endpoint_url;
	} elsif ($xrds_url) {
		$res = HTTP_Client->new->request('GET' => $xrds_url);
		return $this->get_endpoint_url_from_xrds($res->hash) if $res->is_success;
	}
}
return '';
}

sub get_endpoint_url_from_html ($$) {
my($this,$html) = @_;
my($endpoint_url,$xrds_url) = ('','');
if ($html =~ /<meta(?!\w)([^>]+)http-equiv=['"]?x-xrds-location['"]?([^>]+)\/?>/si) {
	my $content = $1 . $2;
	$xrds_url = $1 if $content =~ /\scontent=['"]?(.*?)['"]?(\s|$)/si;
}
if ($html =~ /<link(?!\w)([^>]+)rel=['"]?openid2\.provider['"]?([^>]+)\/?>/si) {
	my $content = $1 . $2;
	$endpoint_url = $1 if $content =~ /\shref=['"]?(.*?)['"]?(\s|$)/si;
} elsif ($html =~ /<link(?!\w)([^>]+)rel=['"]?openid\.server['"]?([^>]+)\/?>/si) {
	my $content = $1 . $2;
	$endpoint_url = $1 if $content =~ /\shref=['"]?(.*?)['"]?(\s|$)/si;
}
return($endpoint_url,$xrds_url);
}

sub get_endpoint_url_from_xrds ($$) {
my($this,$hash) = @_;
my $endpoint_url = '';
if (ref $hash->{'xrds:XRDS'}->{'XRD'}->{'Service'}) {
	$hash->{'xrds:XRDS'}->{'XRD'}->{'Service'} = [$hash->{'xrds:XRDS'}->{'XRD'}->{'Service'}] if ref $hash->{'xrds:XRDS'}->{'XRD'}->{'Service'} eq 'HASH';
	foreach my $service (@{$hash->{'xrds:XRDS'}->{'XRD'}->{'Service'}}) {
		$endpoint_url = $service->{'URI'};
		if (
				(!ref $service->{'Type'} && ($service->{'Type'} eq 'http://specs.openid.net/auth/2.0/signon' || $service->{'Type'} eq 'http://openid.net/signon/1.1'))
			||	(ref $service->{'Type'} && grep($_ eq 'http://specs.openid.net/auth/2.0/signon' || $_ eq 'http://openid.net/signon/1.1',@{$service->{'Type'}}))
		) {
			last;
		}
	}
}
return $endpoint_url;
}

sub is_verified ($$$$$;$) {
my($this,$response,$request_nonce,$return_to,$return_nonce,$claimed_id) = @_;
if ($response->{'openid.mode'}
		&& $return_to && $response->{'openid.return_to'} && $return_to eq $response->{'openid.return_to'}
		&& $return_nonce && $request_nonce && $return_nonce eq $request_nonce
		&& $this->is_same_claimed_id($response->{'openid.claimed_id'},$claimed_id)
		&& $this->check_authentication($response)) {
	return 1;
} else {
	return 0;
}
}

sub is_same_claimed_id ($$$) {
my($this,$new,$old) = @_;
if (!$new) {
	$this->{'message'} = 'ID ߤĤޤ';
	return 0;
} else {
	$new = $this->normalize($new);
	$old = $this->normalize($old);
	if (!$old || $new eq $old) {
		return 1;
	} else {
		$this->{'message'} = 'ID פޤ';
		return 0;
	}
}
}

sub check_authentication ($$) {
my($this,$response) = @_;
$response = {%$response};
$response->{'openid.mode'} = 'check_authentication';
require CMONOS::CGI_Lib::HTTP_Client;
my $res = HTTP_Client->new->request(
	'POST' => $response->{'openid.op_endpoint'},
	{
		'Accept'	=> '*/*',
	},
	$response,
	'utf8'
);
if ($res->is_success) {
	my $params = $res->hash('euc');
	if ($params->{'is_valid'} && $params->{'is_valid'} eq 'true') {
		return 1;
	} else {
		$this->{'message'} = $params->{'error'} if $params->{'error'};
		return 0;
	}
} else {
	$this->{'message'} = $res->message;
	return 0;
}
}

sub normalize ($$) {
my($this,$url) = @_;
if (!$url) {
	return '';
} elsif ($url !~ m!://!) {
	return 'http://' . $url;
}
$url =~ s!^\w+://!http://!gi if $url !~ m!^https?://!i;
$url =~ s/#.*$//;
return $url;
}

sub message ($) {
my $this = shift;
return ($this->{'message'}) ? $this->{'message'} : (wantarray) ? () : '';
}

sub make_nonce ($) {
my $this = shift;
my $nonce = (($ENV{'REMOTE_HOST'}) ? $ENV{'REMOTE_HOST'} : ($ENV{'REMOTE_ADDR'}) ? $ENV{'REMOTE_ADDR'} : time) . $$;
$nonce =~ s/\W//g;
$nonce = '_' . crypt(substr($nonce,-8,8),substr($nonce . time,4,2));
my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday) = gmtime(time);
$year += 1900;
$mon++;
return $year . '-' . sprintf("%.2d", $mon) . '-' . sprintf("%.2d", $mday) .  'T' . sprintf("%.2d", $hour) . ':' . sprintf("%.2d", $min) . ':' . sprintf("%.2d", $sec) . 'Z' . $nonce;
}

sub url_encode ($$;$) {
my($this,$text,$op) = @_;
return '' if !defined $text || $text eq '';
$text =~ s/([\x00-\x1F\x21-\x29\x2B\x2C\x2F\x3A-\x3F\x5B-\x5E\x60\x7B-\xFF])/'%' . sprintf("%.2X", unpack("C", $1))/eg;
$text =~ s/\x20/+/g;
return $text;
}

sub query ($$) {
my($this,$hash) = @_;
my $query = '';
while (my($key,$value) = each %$hash) {
	$query .= '&' . $this->url_encode($key) . '=' . $this->url_encode($value);
}
$query =~ s/^&//;
return $query;
}

1;
