package FrameLib;
require CMONOS::CGI_Lib::Tools::ButtonLib;
@ISA = qw(ButtonLib);
use strict;
######################################################################
# ե졼饤֥Խ⥸塼
# FrameLib.pm ver1.1.4
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-07-16
######################################################################
# 
sub erace_image_css ($) {
my $this = shift;
$this->replace_image_css($main::dir . '-' . $main::id);
}

######################################################################
# ˥塼
sub menu ($$;$$$$) {
my($this,$name,$lib_dir,$id,$list) = @_;
return $this->{'deco_obj'}->frame_menu($name,$main::dir,$id,1,$list,$lib_dir,$main::id);
}

######################################################################
# Ǻ饤֥CSSå
sub image_css_is_ready ($$$$) {
my($this,$image_lib,$dir,$setting) = @_;
my $image_css = $image_lib . '/' . $dir . '/image.css';
if (!-f $image_css) {
	my $css = $this->make_image_css($image_lib,$dir,1);
	$this->write_file($image_css,\$css);
}
return 1;
}

sub make_image_css ($$$;$$) {
my($this,$image_dir,$dir,$is_image_lib,$setting) = @_;
my @dirs = $this->get_image_dir_list($image_dir,$dir);
my $css = '';
my $id;
require CMONOS::CGI_Lib::Frame;
foreach $id (@dirs) {
	my $frame = Frame->new;
	$frame->set(
		'type' => 'frame' . (($is_image_lib) ? '-lib' : ''),
		'id' => $id,
		'library' => $dir,		
		'dir' => $image_dir . '/' . $dir . '/' . $id,		
		(($is_image_lib) ? () : ($this->get_setting_from_image_css($dir . '-' . $id),%{$this->{'deco_obj'}{'setting'}{$dir}{$id}}))
	);
	my $class_name = $dir . '-' . (($is_image_lib) ? 'lib-' : '') . $id;
	$css .= "\x0A\x0A" . $this->mk_image_css_for_frame($class_name,$frame,$dir,$id,$is_image_lib);
}
return $css;
}

sub mk_image_css_for_frame ($$$$$;$) {
my($this,$class_name,$frame,$dir,$id,$is_image_lib) = @_;
return '' if !$frame->{'id'};
$frame->frame_base_change(($is_image_lib) ? $this->{'deco_obj'}->{'image_lib'} . '/' . $dir . '/image.css' : $this->{'image_css'});
my $css = '/* ' . $class_name . ' start */' . "\x0A";
$css .= 'table.' . $class_name . ' {' . "\x0A";
$css .= '  padding: 0 !important;' . "\x0A";
$css .= '  border: none !important;' . "\x0A";
$css .= '  empty-cells: show !important;' . "\x0A";
$css .= '  border-collapse: collapse !important;' . "\x0A";
$css .= '  background-color: ' . (($frame->{'framebgcolor'}) ? $frame->{'framebgcolor'} : 'transparent') . ' !important;' . "\x0A";
$css .= '}' . "\x0A";
$css .= $this->frame_cell_css($class_name,$frame,'tl');
$css .= $this->frame_cell_css($class_name,$frame,'tc','titlebar');
$css .= $this->frame_cell_css($class_name,$frame,'tr');
$css .= $this->frame_cell_css($class_name,$frame,'ml');
$css .= $this->frame_cell_css($class_name,$frame,'mc','contents');
$css .= $this->frame_cell_css($class_name,$frame,'mr');
$css .= $this->frame_cell_css($class_name,$frame,'bl');
$css .= $this->frame_cell_css($class_name,$frame,'bc');
$css .= $this->frame_cell_css($class_name,$frame,'br');
$css .= '/* ' . $class_name . ' end */' . "\x0A";
return $css;
}

sub frame_cell_css ($$$$$) {
my($this,$class_name,$frame,$cell,$type) = @_;
my($tr,$td,$align,$valign,$is_corner,$css);
$tr = ($cell =~ /^t/) ? 'top' : ($cell =~ /^m/) ? 'middle' : 'bottom';
$valign = ($type && $frame->{$type . 'valign'}) ? $frame->{$type . 'valign'} : ($frame->{$cell . 'valign'}) ? $frame->{$cell . 'valign'} : ($cell =~ /^t/) ? 'top' : ($cell =~ /^m/) ? 'middle' : 'bottom';
$td = ($cell =~ /l$/) ? 'left' : ($cell =~ /c$/) ? 'center' : 'right';
$align = ($frame->{$cell . 'align'}) ? $frame->{$cell . 'align'} : ($cell =~ /l$/) ? 'right' : ($cell =~ /c$/) ? 'center' : 'left';
$is_corner = (grep($cell eq $_,('tl','tr','bl','br'))) ? 1 : 0;

$css .= 'table.' . $class_name . ' tr.' . $class_name . '-' . $tr . ' td.' . $class_name . '-' . $td . ' {' . "\x0A";
$css .= '  margin: 0 !important;' . "\x0A";
$css .= '  padding: 0;' . "\x0A";
$css .= '  border: none !important;' . "\x0A";
$css .= '  border-spacing: 0 !important;' . "\x0A";
$css .= '  width: ' . $frame->{$td . 'width'} . 'px !important;' . "\x0A" if $frame->{$td . 'width'};
$css .= '  height: ' . $frame->{$tr . 'height'} . 'px !important;' . "\x0A" if $frame->{$tr . 'height'};
$css .= '  background-color: ' . (($frame->{$cell . 'bgcolor'}) ? $frame->{$cell . 'bgcolor'} : 'transparent') . ' !important;' . "\x0A";
if ($frame->{$cell . 'background'}) {
	$css .= '  background-image: url("' . $frame->{$cell . 'background'} . '") !important;' . "\x0A";
} elsif ($is_corner && $frame->{$cell . 'image'}) {
	$css .= '  background-image: url("' . $frame->{$cell . 'image'} . '") !important;' . "\x0A";
} else {
	$css .= '  background-image: none !important;' . "\x0A";
}
$css .= '  background-position: ' . (($cell eq 'tc') ? 'top' : ($valign eq 'middle') ? 'center' : $valign) . ' ' . $align . ' !important;' . "\x0A";
$css .= '  background-repeat: ' . (($is_corner) ? 'no-repeat' : ($tr eq 'bottom') ? 'repeat-x' : ($td eq 'left' || $td eq 'right') ? 'repeat-y' : 'repeat') . ' !important;' . "\x0A";
$css .= '  text-align: ' . $align . ';' . "\x0A";
$css .= '  vertical-align: ' . $valign . ';' . "\x0A";
$css .= '}' . "\x0A";

if ((!$is_corner && $frame->{$cell . 'image'}) || (($cell eq 'ml' || $cell eq 'mr') && $frame->{$td . 'width'})) {
	$css .= 'table.' . $class_name . ' tr.' . $class_name . '-' . $tr . ' td.' . $class_name . '-' . $td . ' div.' . $class_name . '-object {' . "\x0A";
	if ($frame->{$cell . 'image'}) {
		$css .= '  width: ' . $frame->{$cell . 'imagewidth'} . 'px;' . "\x0A" if $frame->{$cell . 'imagewidth'};
		$css .= '  height: ' . $frame->{$cell . 'imageheight'} . 'px;' . "\x0A" if $frame->{$cell . 'imageheight'};
		$css .= '  background-image: url("' . $frame->{$cell . 'image'} . '");' . "\x0A";
		$css .= '  background-position: top left;' . "\x0A";
		$css .= '  background-repeat: no-repeat;' . "\x0A";
	} else {
		$css .= '  width: ' . $frame->{$td . 'width'} . 'px;' . "\x0A";
		$css .= '  height: 1px;' . "\x0A";	
	}
	$css .= '}' . "\x0A";
}
if ($type) {
	$css .= 'table.' . $class_name . ' div.' . $class_name . '-' . $type . ' {' . "\x0A";
	if ($frame->{$cell . 'align'}) {
		$css .= '  margin-left: auto;' . "\x0A" if $frame->{$cell . 'align'} eq 'center' || $frame->{$cell . 'align'} eq 'right';
		$css .= '  margin-right: auto;' . "\x0A" if $frame->{$cell . 'align'} eq 'center' || $frame->{$cell . 'align'} eq 'left';
	}
	$css .= '  padding: ' . $frame->{$type . 'cellpadding'} . ';' . "\x0A" if $frame->{$type . 'cellpadding'};
	$css .= '  background-color: ' . $frame->{$type . 'bgcolor'} . ';' . "\x0A" if $frame->{$type . 'bgcolor'};
	$css .= '  text-align: ' . (($frame->{$type . 'align'}) ? $frame->{$type . 'align'} : ($type eq 'titlebar') ? 'center' : 'left') . ';' . "\x0A";
	$css .= '  color: ' . $frame->{$type . 'fontcolor'} . ';' . "\x0A" if $frame->{$type . 'fontcolor'};
	$css .= '  font-size: ' . $frame->font_size_to_style($frame->{$type . 'fontsize'}) . ';' . "\x0A" if $frame->{$type . 'fontsize'};
	$css .= '}' . "\x0A";
	if ($type eq 'titlebar') {
		$css .= 'table.' . $class_name . ' div.' . $class_name . '-' . $type . ' h1, table.' . $class_name . ' div.' . $class_name . '-' . $type . ' h2 {' . "\x0A";
		$css .= '  border: none;' . "\x0A";
		$css .= '  background: transparent none;' . "\x0A";
		$css .= '  padding: 0;' . "\x0A";
		$css .= '  margin: 0;' . "\x0A";
		$css .= '  font-size: 1em;' . "\x0A";
		$css .= '  font-weight: bold;' . "\x0A";
		$css .= '  color: ' . $frame->{$type . 'fontcolor'} . ';' . "\x0A" if $frame->{$type . 'fontcolor'};
		$css .= '}' . "\x0A";
	}
}
return $css;
}

sub get_setting_from_image_css ($$) {
my($this,$class_name) = @_;
my %setting = ();
my $image_css = $this->read_file($this->{'image_css'});
if ($image_css =~ m!/\* $class_name start \*/(.*?)/\* $class_name end \*/\x0A!s) {
	$image_css = $1;
	if ($image_css =~ /table\.$class_name {(.*?)}/s) {
		my $css = $1;
		$setting{'framebgcolor'} = $1 if $css =~ /\s+background-color: (#\w+)/;
	}
	if ($image_css =~ /table\.$class_name div\.$class_name-titlebar {(.*?)}/s) {
		my $css = $1;
		$setting{'titlebarbgcolor'} = $1 if $css =~ /\s+background-color: (#\w+)/;
		$setting{'titlebarfontcolor'} = $1 if $css =~ /\s+color: (#\w+)/;
		$setting{'titlebarfontsize'} = $this->style_to_font_size($1) if $css =~ /\s+font-size: ([\.\w]+)/;
		$setting{'titlebaralign'} = $1 if $css =~ /\s+text-align: (\w+)/;
		$setting{'titlebarcellpadding'} = $1 if $css =~ /\s+padding: (\d+)/;
	}
	if ($image_css =~ /table\.$class_name div\.$class_name-contents {(.*?)}/s) {
		my $css = $1;
		$setting{'contentsbgcolor'} = $1 if $css =~ /\s+background-color: (#\w+)/;
		$setting{'contentsfontcolor'} = $1 if $css =~ /\s+color: (#\w+)/;
		$setting{'contentsfontsize'} = $this->style_to_font_size($1) if $css =~ /\s+font-size: ([\.\w]+)/;
		$setting{'contentsalign'} = $1 if $css =~ /\s+text-align: (\w+)/;
		$setting{'contentscellpadding'} = $1 if $css =~ /\s+padding: (\d+)/;
	}
	if ($image_css =~ /table\.$class_name tr.$class_name-top td.$class_name-center {(.*?)}/s) {
		my $css = $1;
		$setting{'tcalign'} = $1 if $css =~ /\s+text-align: (\w+)/;
		$setting{'tcvalign'} = $1 if $css =~ /\s+vertical-align: (\w+)/;
	}
	if ($image_css =~ /table\.$class_name tr.$class_name-middle td.$class_name-center {(.*?)}/s) {
		my $css = $1;
		$setting{'mcalign'} = $1 if $css =~ /\s+text-align: (\w+)/;
		$setting{'mcvalign'} = $1 if $css =~ /\s+vertical-align: (\w+)/;
		$setting{'mcbgcolor'} = $1 if $css =~ /\s+background-color: (#\w+)/;
	}
}
return %setting;
}

sub style_to_font_size ($$) {
my($this,$size) = @_;
if ($size eq '0.67em') {
	return '1';
} elsif ($size eq '0.83em') {
	return '2';
} elsif ($size eq '1em') {
	return '3';
} elsif ($size eq '1.17em') {
	return '4';
} elsif ($size eq '1.5em') {
	return '5';
} elsif ($size eq '2em') {
	return '6';
} elsif ($size eq '3em') {
	return '7';
} else {
	return $size;
}
}

######################################################################
# ե
sub print_setting_form ($) {
my $this = shift;
%main::setting = $this->get_setting_from_image_css($main::dir . '-' . $main::id) if !%main::setting && $main::dir && $main::id;

print '<fieldset><legend>ե졼</legend>';
print '<table class="field-table"><tbody><tr class="tbody-end">';
print '<td class="field-name"><label for="setting:type">ե졼ॿ</label></td>';
print '<td class="q-field">';

print $this->mk_select_menu(
	'setting:type','','',$frame::obj{$main::dir}{$main::id}->{'type'},
	'frame'		=>		'Ρޥ',
	'tab'		=>		'ַ',
	'bar'		=>		'С'
);

print '</td></tr>';
print '</tbody><tbody>';
print '<tr>';
print '<td class="field-name"><label for="setting:titlebarfontcolor">ȥʸ</label></td><td class="q-field"><input name="setting:titlebarfontcolor" id="setting:titlebarfontcolor" type="text" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'setting:titlebarfontcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" value="' . $this->escape($main::setting{'titlebarfontcolor'}) . '" style="background-color: ' . $this->escape($main::setting{'titlebarfontcolor'}) . '" />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'setting:titlebarfontcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'setting:titlebarfontcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'setting:titlebarfontcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'setting:titlebarfontcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</td><td class="field-name"><label for="setting:titlebarfontsize">ȥʸ</label></td>';
print '<td class="q-field">';

print $this->mk_select_menu(
	'setting:titlebarfontsize','','',$main::setting{'titlebarfontsize'},
	''		=>		'',
	'1'		=>		'',
	'2'		=>		'侮',
	'3'		=>		'ɸ',
	'4'		=>		'礭',
	'5'		=>		'礭',
	'6'		=>		'礭',
	'7'		=>		'礭'
);

print '</td></tr>';
print '<tr>';
print '<td class="field-name"><label for="setting:titlebaralign">ȥ·</label></td>';
print '<td class="q-field">';

print $this->mk_select_menu(
	'setting:titlebaralign','','',$main::setting{'titlebaralign'},
	''			=>		'',
	'left'		=>		'',
	'center'	=>		'',
	'right'		=>		''
);

print '</td><td class="field-name"><label for="setting:tcalign">ȥ·</label></td>';
print '<td class="q-field">';

print $this->mk_select_menu(
	'setting:tcalign','','',$main::setting{'tcalign'},
	''			=>		'',
	'left'		=>		'',
	'center'	=>		'',
	'right'		=>		''
);

print $this->mk_select_menu(
	'setting:tcvalign','','',$main::setting{'tcvalign'},
	''			=>		'',
	'top'		=>		'',
	'middle'	=>		'',
	'bottom'	=>		''
);

print '</td></tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="setting:titlebarcellpadding">ȥ;</label></td><td class="q-field"><input name="setting:titlebarcellpadding" id="setting:titlebarcellpadding" type="text" size="7" maxlength="7" value="' . $this->escape($main::setting{'titlebarcellpadding'}) . '" /> <span class="unit">ԥ</span></td>';
print '<td class="field-name"><label for="setting:titlebarbgcolor">ȥطʿ</label></td><td class="q-field"><input name="setting:titlebarbgcolor" id="setting:titlebarbgcolor" type="text" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'setting:titlebarbgcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" value="' . $this->escape($main::setting{'titlebarbgcolor'}) . '" style="background-color: ' . $this->escape($main::setting{'titlebarbgcolor'}) . '" />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'setting:titlebarbgcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'setting:titlebarbgcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'setting:titlebarbgcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'setting:titlebarbgcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</td></tr>';

print '</tbody><tbody>';

print '<tr>';
print '<td class="field-name"><label for="setting:contentsfontcolor">ƥʸ</label></td>';
print '<td class="q-field"><input name="setting:contentsfontcolor" id="setting:contentsfontcolor" type="text" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'setting:contentsfontcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" value="' . $this->escape($main::setting{'contentsfontcolor'}) . '" style="background-color: ' . $this->escape($main::setting{'contentsfontcolor'}) . '" />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'setting:contentsfontcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'setting:contentsfontcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'setting:contentsfontcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'setting:contentsfontcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</td><td class="field-name"><label for="setting:contentsfontsize">ƥʸ</label></td>';
print '<td class="q-field">';

print $this->mk_select_menu(
	'setting:contentsfontsize','','',$main::setting{'contentsfontsize'},
	''		=>		'',
	'1'		=>		'',
	'2'		=>		'侮',
	'3'		=>		'ɸ',
	'4'		=>		'礭',
	'5'		=>		'礭',
	'6'		=>		'礭',
	'7'		=>		'礭'
);

print '</td></tr>';
print '<tr>';
print '<td class="field-name"><label for="setting:contentsalign">ƥĹ·</label></td>';
print '<td class="q-field">';

print $this->mk_select_menu(
	'setting:contentsalign','','',$main::setting{'contentsalign'},
	''			=>		'',
	'left'		=>		'',
	'center'	=>		'',
	'right'		=>		''
);

print '</td><td class="field-name"><label for="setting:mcalign">ƥİ·</label></td>';
print '<td class="q-field">';

print $this->mk_select_menu(
	'setting:mcalign','','',$main::setting{'mcalign'},
	''			=>		'',
	'left'		=>		'',
	'center'	=>		'',
	'right'		=>		''
);

print $this->mk_select_menu(
	'setting:mcvalign','','',$main::setting{'mcvalign'},
	''			=>		'',
	'top'		=>		'',
	'middle'	=>		'',
	'bottom'	=>		''
);

print '</td></tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="setting:contentscellpadding">ƥ;</label></td><td class="q-field"><input name="setting:contentscellpadding" id="setting:contentscellpadding" type="text" size="7" maxlength="7" value="' . $this->escape($main::setting{'contentscellpadding'}) . '" />';
print ' <span class="unit">ԥ</span></td>';
print '<td class="field-name"><label for="setting:contentsbgcolor">ƥطʿ</label></td><td class="q-field"><input name="setting:contentsbgcolor" id="setting:contentsbgcolor" type="text" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'setting:contentsbgcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" value="' . $this->escape($main::setting{'contentsbgcolor'}) . '" style="background-color: ' . $this->escape($main::setting{'contentsbgcolor'}) . '" />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'setting:contentsbgcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'setting:contentsbgcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'setting:contentsbgcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'setting:contentsbgcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</td></tr>';

print '</tbody><tbody>';

print '<tr class="tbody-end">';
print '<td class="field-name"><label for="setting:mcbgcolor">طʿ</label></td><td class="q-field"><input name="setting:mcbgcolor" id="setting:mcbgcolor" type="text" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'setting:mcbgcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" value="' . $this->escape($main::setting{'mcbgcolor'}) . '" style="background-color: ' . $this->escape($main::setting{'mcbgcolor'}) . '" />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'setting:mcbgcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'setting:mcbgcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'setting:mcbgcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'setting:mcbgcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</td><td class="field-name"><label for="setting:framebgcolor">طʿ</label></td><td class="q-field"><input name="setting:framebgcolor" id="setting:framebgcolor" type="text" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'setting:framebgcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" value="' . $this->escape($main::setting{'framebgcolor'}) . '" style="background-color: ' . $this->escape($main::setting{'framebgcolor'}) . '" />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'setting:framebgcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'setting:framebgcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'setting:framebgcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'setting:framebgcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</td></tr></tbody></table>';

print '<div class="submit"><input type="submit" value="¸" /></div>' if defined $main::id && $main::id ne '';
print '</fieldset>';
}

######################################################################
# Ͽ
sub set_image ($) {
my $this = shift;

if (defined $main::setting{'titlebarfontcolor'} && $main::setting{'titlebarfontcolor'} ne '' && $this->is_invalid_color($main::setting{'titlebarfontcolor'})) {
	push(@{$cgi::action->{'dialog'}},'ȥʸǧƤ') if ref $cgi::action;
	delete $main::setting{'titlebarfontcolor'};
}
if (defined $main::setting{'titlebarbgcolor'} && $main::setting{'titlebarbgcolor'} ne '' && $this->is_invalid_color($main::setting{'titlebarbgcolor'})) {
	push(@{$cgi::action->{'dialog'}},'ȥطʿǧƤ') if ref $cgi::action;
	delete $main::setting{'titlebarbgcolor'};
}
if (defined $main::setting{'titlebarcellpadding'} && $main::setting{'titlebarcellpadding'} ne '' && $this->is_nan($main::setting{'titlebarcellpadding'})) {
	push(@{$cgi::action->{'dialog'}},'ȥ;򹹿ǤޤǤȾѿˤƤ');
	delete $main::setting{'titlebarcellpadding'};
}
if (defined $main::setting{'contentsfontcolor'} && $main::setting{'contentsfontcolor'} ne '' && $this->is_invalid_color($main::setting{'contentsfontcolor'})) {
	push(@{$cgi::action->{'dialog'}},'ƥʸǧƤ') if ref $cgi::action;
	delete $main::setting{'contentsfontcolor'};
}
if (defined $main::setting{'contentsbgcolor'} && $main::setting{'contentsbgcolor'} ne '' && $this->is_invalid_color($main::setting{'contentsbgcolor'})) {
	push(@{$cgi::action->{'dialog'}},'ƥطʿǧƤ') if ref $cgi::action;
	delete $main::setting{'contentsbgcolor'};
}
if (defined $main::setting{'contentscellpadding'} && $main::setting{'contentscellpadding'} ne '' && $this->is_nan($main::setting{'contentscellpadding'})) {
	push(@{$cgi::action->{'dialog'}},'ƥ;򹹿ǤޤǤȾѿˤƤ');
	delete $main::setting{'contentscellpadding'};
}
if (defined $main::setting{'mcbgcolor'} && $main::setting{'mcbgcolor'} ne '' && $this->is_invalid_color($main::setting{'mcbgcolor'})) {
	push(@{$cgi::action->{'dialog'}},'طʿǧƤ') if ref $cgi::action;
	delete $main::setting{'mcbgcolor'};
}
if (defined $main::setting{'framebgcolor'} && $main::setting{'framebgcolor'} ne '' && $this->is_invalid_color($main::setting{'framebgcolor'})) {
	push(@{$cgi::action->{'dialog'}},'طʿǧƤ') if ref $cgi::action;
	delete $main::setting{'framebgcolor'};
}

require CMONOS::CGI_Lib::Frame;
my $frame = Frame->new;
$frame->set(
	'library' => $main::dir,		
	'id' => $main::id,
	'dir' => "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id",
	%main::setting
);
my $class_name = $main::dir . '-' . $main::id;
$this->replace_image_css($class_name,$this->mk_image_css_for_frame($class_name,$frame,$main::dir,$main::id));
$this->set_deco($main::dir,$main::id,{'type' => (($main::setting{'type'}) ? $main::setting{'type'} : 'frame')});
}

######################################################################
# åץɥե
sub print_upload_form ($$) {
my($this,$save_button) = @_;
print '<fieldset id="frame-uploader"><legend>ꥸʥե졼</legend>';
print '<table><tbody>';
print '<tr>';
print '<td><label for="image:tl"></label><input type="file" name="image:tl" id="image:tl" /></td>';
print '<td><label for="image:tcbg"></label><input type="file" name="image:tcbg" id="image:tcbg" /></td>';
print '<td><label for="image:tr"></label><input type="file" name="image:tr" id="image:tr" /></td>';
print '</tr>';
print '<tr>';
print '<td><label for="image:mlbg"></label><input type="file" name="image:mlbg" id="image:mlbg" /></td>';
print '<td><label for="image:mcbg"></label><input type="file" name="image:mcbg" id="image:mcbg" /></td>';
print '<td><label for="image:mrbg"></label><input type="file" name="image:mrbg" id="image:mrbg" /></td>';
print '</tr>';
print '<tr>';
print '<td><label for="image:bl"></label><input type="file" name="image:bl" id="image:bl" /></td>';
print '<td><label for="image:bcbg"></label><input type="file" name="image:bcbg" id="image:bcbg" /></td>';
print '<td><label for="image:br"></label><input type="file" name="image:br" id="image:br" /></td>';
print '</tr></tbody></table>';
print '<div class="submit"><input type="submit" value="' . $save_button . '" /></div></fieldset>';
}

sub unlink_my_files ($) {
my $this = shift;
$this->unlink_image_files($this->get_my_files);
}

sub is_invalid_images ($) {
my $this = shift;
return 0;
}

sub get_my_files ($) {
my $this = shift;
return (
	'tl','tc','tr',
	'ml','mc','mr',
	'bl','bc','br',
	'tlbg','tcbg','trbg',
	'mlbg','mcbg','mrbg',
	'blbg','bcbg','brbg'
);
}

######################################################################
# ID
sub get_id ($$) {
my($this,$dir) = @_;
my($num);
while (1) {
	$num++;
	last if !ref $frame::obj{$dir}{$num} || !%{$frame::obj{$dir}{$num}};
}
return $num;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#饹Ͽ
	$ImageLib::modules{'frame'} = 'FrameLib';
}


1;