package CalMonthlyView;
require CMONOS::Calendar::CalDayView;
@ISA = qw(CalDayView);
use strict;
######################################################################
# ɽ⥸塼
# CalMonthlyView.pm ver1.0.5
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-05-03
######################################################################
# ֥Ⱥ
sub new ($) {
my $pkg = shift;
my $this = {};
bless $this, $pkg;
return $this;
}

sub need_day_events ($) {
my $this = shift;
return 1;
}

sub get_target_dates ($$) {
my($this,$date) = @_;
if ($date =~ /^(\d{4})(\d{2})(\d{2})$/) {
	my($y,$m,$d) = ($1,$2+0,$3+0);
	my @dates = ();
	my $last = $this->get_last_mday($y,$m);
	my $first = $this->get_wday($y,$m,1);
	my $cell = $last + $first - (($last + $first) % 7) + ((($last + $first) % 7 > 0) ? 7 : 0);
	if ($first) {
		my($prev_y,$prev_m,$prev_last);
		if ($m == 1) {
			$prev_y = $y - 1;
			$prev_m = 12;	
		} else {
			$prev_y = $y;
			$prev_m = $m - 1;	
		}
		$prev_last = $this->get_last_mday($prev_y,$prev_m);
		for (my $i = ($prev_last - $first + 1); $i <= $prev_last; $i++) {
			push(@dates,$prev_y . sprintf("%.2d", $prev_m) . sprintf("%.2d", $i))
		}
	}
	for (my $i = 1; $i <= $last; $i++) {
		push(@dates,$y . sprintf("%.2d", $m) . sprintf("%.2d", $i))
	}
	my $rest = $cell - $first - $last;
	if ($rest) {
		my($next_y,$next_m);
		if ($m == 12) {
			$next_y = $y + 1;
			$next_m = 1;	
		} else {
			$next_y = $y;
			$next_m = $m + 1;	
		}
		for (my $i = 1; $i <= $rest; $i++) {
			push(@dates,$next_y . sprintf("%.2d", $next_m) . sprintf("%.2d", $i))
		}
	}
	return @dates;
} else {
	return ();
}
}

sub prev_calendar_date ($$) {
my($this,$date) = @_;
if ($date =~ /^(\d{4})(\d{2})(\d{2})$/) {
	my($y,$m,$d) = ($1,$2+0,$3+0);
	if ($m == 1) {
		$y--;
		$m = 12;	
	} else {
		$m--;	
	}
	return $y . sprintf("%.2d", $m) . sprintf("%.2d", $d);
} else {
	return $date;
}
}

sub next_calendar_date ($$) {
my($this,$date) = @_;
if ($date =~ /^(\d{4})(\d{2})(\d{2})$/) {
	my($y,$m,$d) = ($1,$2+0,$3+0);
	if ($m == 12) {
		$y++;
		$m = 1;	
	} else {
		$m++;	
	}
	return $y . sprintf("%.2d", $m) . sprintf("%.2d", $d);
} else {
	return $date;
}
}

sub page_title ($$) {
my($this,$date) = @_;
if ($date =~ /^(\d{4})(\d{2})/) {
	my($y,$m) = ($1,$2+0);
	return $y . 'ǯ' . $m . '';
}
return '';
}

sub calendar_type ($) {
my $this = shift;
return 'monthly';
}

sub day_limit ($) {
my $this = shift;
return 7;
}

sub print_hourly_events_list ($$) {
my($this,$date) = @_;
my $e = 0;
#no warnings qw(numeric);
foreach my $h (sort {$a <=> $b} keys %{$this->{'date'}{$date}{'time'}}) {
	foreach my $n (sort {$this->{'event'}{$a}{'start_date'} <=> $this->{'event'}{$b}{'start_date'} || $this->{'event'}{$a}{'start_time'} <=> $this->{'event'}{$b}{'start_time'} || $a <=> $b} keys %{$this->{'date'}{$date}{'time'}{$h}}) {
		my $this_event = $this->{'date'}{$date}{'time'}{$h}{$n};
		next if !defined $this_event->{'start_min'};
		next if $this_event->{'prev'} && !$this_event->{'next'} && !$this_event->{'end_time'} && !$this->{'event'}{$n}{'end_time'};
		print '<ol class="event-list">' if !$e;
		print '<li>';
		print '<a';
		print ' class="event-category-' . (($this->{'event'}{$n}{'category'}) ? $this->{'event'}{$n}{'category'} : '1') . '"';
		print ' href="' . $cgi::path . '?m=DetailViewer' . (($default::subdivided && $main::c) ? '&amp;c=' . $main::c : '') . '&amp;n=' . (($n =~ /^(\d+)\.\d+$/) ? $1 : $n) . '&amp;v=' . $main::v . '"';
		print ' target="detailViewer"';
		print ' onclick="' . $this->detail_viewer_opener . '"';
		print ' title="' . $this->get_span($n) . '"';
		print '>';
		print (($this_event->{'start_time'} && $this_event->{'start_time'} =~ /^(\d{2})(\d{2})/) ? '<span class="start-time">' . ($1+0) . ':' . $2 . '</span>' : ($this_event->{'prev'}) ? '<span class="start-time">0:00</span>' : ($this->{'event'}{$n}{'start_time'} =~ /^(\d{2})(\d{2})/) ? '<span class="start-time">' . ($1+0) . ':' . $2 . '</span>' : '');
		print $this->cut_string(((defined $this->{'event'}{$n}{'title'} && $this->{'event'}{$n}{'title'} ne '') ? $this->{'event'}{$n}{'title'} : ($default::english) ? 'EVENT' : 'ͽ'),32,'i');
		print '</a>';
		print '</li>';
		$e = 1;
	}
}
print '</ol>' if $e;
}

sub print_hourly_events ($) {
my $this = shift;
}

sub print_event_separator ($) {
my $this = shift;
print '</tr><tr>';
}



1;
