package FeedMixer;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use Fcntl qw(:flock);
use Time::Local;
######################################################################
# եɥߥ⥸塼
# FeedMixer.pm ver1.0.4
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-05-30
######################################################################
# ᥤ
sub run ($;$) {
my($this,$mkfile_flag) = @_;
my($cache_file,$list,$template,$article_template,@feeds,%required,%article,$count,$max);
local(*OUT);

#ڡإå
if ($mkfile_flag) {
	if (defined $setting::security{'feed'}{'passwordCheck'} && $setting::security{'feed'}{'passwordCheck'} eq 'nocheck') {
		if (open (OUT, ">>$default::file")) {
			binmode OUT;
			flock(OUT, LOCK_EX);
			truncate(OUT, 0);
			seek(OUT, 0, 0);
			$cache_file = $default::file;
		} else {
			$this->print_invisible_gif;
			return;
		}
	} else {
		$this->write_file($default::file,'',1);
		$this->write_file($default::file,'',1) if $default::file =~ s/\.ssi$/.js/;
		$this->print_invisible_gif;
		return;
	}
} else {
	if (defined $main::mode && $main::mode eq 'ssi') {
		$this->print_http_header('text/html');
		$cache_file = $default::preference_dir . '/ssi_cache.html';
	} elsif (defined $main::mode && $main::mode eq 'js') {
		$this->print_http_header('text/javascript');
		$cache_file = $default::preference_dir . '/ssi_cache.js';
	} else {
		$this->print_http_header('text/html');
		$cache_file = $default::preference_dir . '/cache.html';
	}
	if (!$main::refresh && -s $cache_file) {
		my $ltime = time - $default::interval * 3600;
		my $mtime = (stat($cache_file))[9];
		if ($mtime && $ltime && $mtime > $ltime) {
			$this->print_cache($cache_file);
			return;
		}
	}
	$cache_file = $default::preference_dir . '/ssi_cache.html' if defined $main::mode && $main::mode eq 'js';
	if (open (OUT, ">>$cache_file")) {
		binmode OUT;
		flock(OUT, LOCK_EX);
		truncate(OUT, 0);
		seek(OUT, 0, 0);
		$this->print_page_header($setting::key,\*OUT) if !$main::mode;
	} else {
		print '';
		return;
	}
}

#ե륿
my(@required_words,@ignore_words);
if ($setting::general{'requiredWords'}) {
	@required_words = split(/(?:\s|\xa1\xa1)+/,$setting::general{'requiredWords'});
}
if ($setting::general{'ignoreWords'}) {
	@ignore_words = split(/(?:\s|\xa1\xa1)+/,$setting::general{'ignoreWords'});
}

if (!$setting::page{$setting::key}{'template'}) {
$template = <<TEMP;
<!--mtime--><!--/mtime--> 
<ul class="index">
<!--article--><li><!--title--><!--/title--><!--site head=" (" foot=")"--><!--/site--></li><!--/article-->
</ul>
TEMP
} else {
	$template = $setting::page{$setting::key}{'template'};
}
$template = $this->page_item_replace($template,0,'',$setting::page{$setting::key}{'title'});
if ($template =~ /<!--frame(?!\w)([^>]*)-->/) {
	require CMONOS::CGI_Lib::Frame;
	my $frame = Frame->new;
	$template = $frame->text_to_frame($template,'no',$frame::obj{'frame'},'',(($mkfile_flag) ? 'abs' : ''));
}
$article_template = ($template =~ s/<!--article(?!\w)([^>]*)-->(.*?)(<!--\/article-->)/<!--article--><!--\/article-->/sg) ? $this->join_header_and_footer($1,$2) : '<li><!--title--><!--/title--><!--site head=" (" foot=")"--><!--/site--></li>';
foreach my $ele ('title','description','content','site','author','link','mtime','date') {
	$required{$ele} = 1 if $article_template =~ /<!--$ele(?!\w)[^>]*-->/s;
}
$template =~ s/<\!--mtime(?!\w)([^>]*)-->(.*?)<\!--\/mtime-->/$this->date_replace(time,$1,$2,0,(($main::mode) ? () : ($cgi::path . '?refresh=1','')))/sge;
$template =~ s/<\!--date(?!\w)([^>]*)-->(.*?)<\!--\/date-->/$this->date_replace(time,$1,$2,1)/sge;
require CMONOS::CGI_Lib::HTTP_Client;
@feeds = split(/[\x0A\x0D]+/,$setting::general{'feeds'});
FEED:
foreach my $url (@feeds) {
	my($hash);
	if ($url =~ m!^/!) {
		$hash = HTTP_Client->new->get_hash_from_xml($cgi::Jcode->set($this->read_file($this->path_change($url),1),'utf8')->euc);
	} elsif ($url =~ m!^https?://!i) {
		my $res = HTTP_Client->new->request('GET' => $url);
		$hash = $res->hash('euc') if $res->is_success;
	}
	if (ref $hash) {
		my($site,$site_url,$limit,$description_length);
		$limit = $setting::page{$setting::key}{'limit'} || 4;
		$description_length = $setting::page{$setting::key}{'descriptionLength'} || 128;
		if (ref $hash->{'rss'}) {
			$site = $hash->{'rss'}->{'channel'}->{'title'} if defined $hash->{'rss'}->{'channel'}->{'title'};
			$site_url = $hash->{'rss'}->{'channel'}->{'link'} if defined $hash->{'rss'}->{'channel'}->{'link'};
			if (ref $hash->{'rss'}->{'channel'}->{'item'}) {
				my $n = 0;
				$hash->{'rss'}->{'channel'}->{'item'} = [$hash->{'rss'}->{'channel'}->{'item'}] if ref $hash->{'rss'}->{'channel'}->{'item'} eq 'HASH';
				ITEM:
				foreach my $item (@{$hash->{'rss'}->{'channel'}->{'item'}}) {
					last ITEM if $n >= $limit;
					my $id = (ref $item->{'guid'} && defined $item->{'guid'}->{'value'}) ? $item->{'guid'}->{'value'} : (defined $item->{'guid'}) ? $item->{'guid'} : (defined $item->{'dc:identifier'}) ? $item->{'dc:identifier'} : (defined $item->{'link'}) ? $item->{'link'} : $url . '#' . $n;
					$article{$id}{'mtime'} = $this->date_to_gmt(($item->{'pubDate'}) ? $item->{'pubDate'} : ($item->{'dc:date'}) ? $item->{'dc:date'} : time);
					$article{$id}{'link'} = $item->{'link'} || $item->{'guid'} || $site_url || $url;
					$article{$id}{'site'} = $this->detag($site) if defined $site;
					$article{$id}{'site_url'} = $site_url if defined $site_url;
					$article{$id}{'title'} = $this->detag($item->{'title'}) if $required{'title'} && defined $item->{'title'};
					$article{$id}{'description'} = $this->cut_string($this->detag((defined $item->{'description'}) ? $item->{'description'} : (defined $item->{'content'}) ? $item->{'content'} : (defined $item->{'content:encoded'}) ? $item->{'content:encoded'} : ''),$description_length) if $required{'description'};
					$article{$id}{'content'} = $this->tag_fix((defined $item->{'content'}) ? $item->{'content'} : (defined $item->{'content:encoded'}) ? $item->{'content:encoded'} : (defined $item->{'description'}) ? $item->{'description'} : '') if $required{'content'};
					$article{$id}{'author'} = $this->detag((defined $item->{'author'}) ? $item->{'author'} : (defined $item->{'dc:creator'}) ? $item->{'dc:creator'} : (defined $item->{'dc:publisher'}) ? $item->{'dc:publisher'} : '') if $required{'author'};
					if ($this->is_not_required($article{$id},\@required_words,\@ignore_words)) {
						delete $article{$id};
					} else {
						$n++;
					}
				}
			}
		} elsif (ref $hash->{'rdf:RDF'}) {
			$site = $hash->{'rdf:RDF'}->{'channel'}->{'title'} if defined $hash->{'rdf:RDF'}->{'channel'}->{'title'};
			$site_url = $hash->{'rdf:RDF'}->{'channel'}->{'link'} if defined $hash->{'rdf:RDF'}->{'channel'}->{'link'};
			if (ref $hash->{'rdf:RDF'}->{'item'}) {
				my $n = 0;
				$hash->{'rdf:RDF'}->{'item'} = [$hash->{'rdf:RDF'}->{'item'}] if ref $hash->{'rdf:RDF'}->{'item'} eq 'HASH';
				ITEM:
				foreach my $item (@{$hash->{'rdf:RDF'}->{'item'}}) {
					last ITEM if $n >= $limit;
					my $id = (ref $item->{'guid'} && defined $item->{'guid'}->{'value'}) ? $item->{'guid'}->{'value'} : (defined $item->{'guid'}) ? $item->{'guid'} : (defined $item->{'dc:identifier'}) ? $item->{'dc:identifier'} : (defined $item->{'link'}) ? $item->{'link'} : $url . '#' . $n;
					$article{$id}{'mtime'} = $this->date_to_gmt(($item->{'pubDate'}) ? $item->{'pubDate'} : ($item->{'dc:date'}) ? $item->{'dc:date'} : time);
					$article{$id}{'link'} = $item->{'link'} || $item->{'guid'} || $site_url || $url;
					$article{$id}{'site'} = $this->detag($site) if defined $site;
					$article{$id}{'site_url'} = $site_url if defined $site_url;
					$article{$id}{'title'} = $this->detag($item->{'title'}) if $required{'title'} && defined $item->{'title'};
					$article{$id}{'description'} = $this->cut_string($this->detag((defined $item->{'description'}) ? $item->{'description'} : (defined $item->{'content'}) ? $item->{'content'} : (defined $item->{'content:encoded'}) ? $item->{'content:encoded'} : ''),$description_length) if $required{'description'};
					$article{$id}{'content'} = $this->tag_fix((defined $item->{'content'}) ? $item->{'content'} : (defined $item->{'content:encoded'}) ? $item->{'content:encoded'} : (defined $item->{'description'}) ? $item->{'description'} : '') if $required{'content'};
					$article{$id}{'author'} = $this->detag((defined $item->{'author'}) ? $item->{'author'} : (defined $item->{'dc:creator'}) ? $item->{'dc:creator'} : (defined $item->{'dc:publisher'}) ? $item->{'dc:publisher'} : '') if $required{'author'};
					if ($this->is_not_required($article{$id},\@required_words,\@ignore_words)) {
						delete $article{$id};
					} else {
						$n++;
					}
				}
			}
		} elsif (ref $hash->{'feed'}) {
			$site = (ref $hash->{'feed'}->{'title'}) ? $hash->{'feed'}->{'title'}->{'value'} : $hash->{'feed'}->{'title'} if defined $hash->{'feed'}->{'title'};
			$site_url = $this->get_atom_value($hash->{'feed'}->{'link'},'html','href') if defined $hash->{'feed'}->{'link'};
			if (ref $hash->{'feed'}->{'entry'}) {
				my $n = 0;
				$hash->{'feed'}->{'entry'} = [$hash->{'feed'}->{'entry'}] if ref $hash->{'feed'}->{'entry'} eq 'HASH';
				ITEM:
				foreach my $item (@{$hash->{'feed'}->{'entry'}}) {
					last if $n >= $limit;
					my $id = (defined $item->{'id'}) ? $item->{'id'} : (ref $item->{'link'}) ? $this->get_atom_value($item->{'link'},'html','href') : $url . '#' . $n;
					$article{$id}{'mtime'} = $this->date_to_gmt(($item->{'updated'}) ? $item->{'updated'} : ($item->{'modified'}) ? $item->{'modified'} : ($item->{'published'}) ? $item->{'published'} : ($item->{'issued'}) ? $item->{'issued'} : time);
					$article{$id}{'link'} = $this->get_atom_value($item->{'link'},'html','href') || $site_url || $url;
					$article{$id}{'site'} = $this->detag($site) if defined $site;
					$article{$id}{'site_url'} = $site_url if defined $site_url;
					$article{$id}{'title'} = $this->detag((ref $item->{'title'}) ? $item->{'title'}->{'value'} : $item->{'title'}) if $required{'title'} && defined $item->{'title'};
					$article{$id}{'description'} = $this->cut_string($this->detag((ref $item->{'summary'}) ? $item->{'summary'}->{'value'} : (defined $item->{'summary'}) ? $item->{'summary'} : $this->tag_fix($this->get_atom_value($item->{'content'},'html','value'))),$description_length) if $required{'description'};
					$article{$id}{'content'} = $this->tag_fix($this->get_atom_value($item->{'content'},'html','value')) if $required{'content'} && defined $item->{'content'};
					$article{$id}{'author'} = $this->detag($item->{'author'}->{'name'}) if $required{'author'} && ref $item->{'author'} eq 'HASH' && defined $item->{'author'}->{'name'};
					if ($this->is_not_required($article{$id},\@required_words,\@ignore_words)) {
						delete $article{$id};
					} else {
						$n++;
					}
				}
			}
		}
	}
}
$list = '';
$count = 0;
$max = ($setting::page{$setting::key}{'max'}) ? $setting::page{$setting::key}{'max'} : 0;
foreach my $id (sort {$article{$b}{'mtime'} <=> $article{$a}{'mtime'} || $a cmp $b} keys %article) {
	last if $max && ++$count > $max;
	my $temp = $article_template;
	my $is_linked = 0;
	$article{$id}{'link'} =~ s/[\?\&]utm_source=[^\&=]*&utm_medium=[^\&=]*//i;
	if ($required{'site'}) {
		my $site = (defined $article{$id}{'site'} && $article{$id}{'site'} ne '') ? (defined $article{$id}{'site_url'} && $article{$id}{'site_url'} ne '') ? '<a href="' . $this->escape($article{$id}{'site_url'}) . '"' . (($setting::general{'nofollow'}) ? ' rel="nofollow"' : '') . (($setting::page{$setting::key}{'window'}) ? ' target="_blank"' : '') . '>' . $article{$id}{'site'} . '</a>' : $article{$id}{'site'} : '';
		$temp =~ s/<\!--site(?!\w)([^>]*)-->(.*?)<\!--\/site(?!\w)[^>]*-->/$this->item_tag_replace('site',$1,$2,$site)/ges;
	}
	if ($required{'title'}) {
		my $title = (defined $article{$id}{'title'} && $article{$id}{'title'} ne '') ? '<a href="' . $this->escape($article{$id}{'link'}) . '"' . (($setting::general{'nofollow'}) ? ' rel="nofollow"' : '') . (($setting::page{$setting::key}{'window'}) ? ' target="_blank"' : '') . (($article{$id}{'site'}) ? ' title="' . $this->escape_without_html_entity($article{$id}{'site'}) . '"' : '') . '>' . $article{$id}{'title'} . '</a>' : '';
		$temp =~ s/<\!--title(?!\w)([^>]*)-->(.*?)<\!--\/title(?!\w)[^>]*-->/$this->item_tag_replace('title',$1,$2,$title)/ges;
		$is_linked = 1;
	}
	if ($required{'link'}) {
		my $link = (defined $article{$id}{'link'} && $article{$id}{'link'} ne '') ? '<a href="' . $this->escape($article{$id}{'link'}) . '"' . (($setting::general{'nofollow'}) ? ' rel="nofollow"' : '') . (($setting::page{$setting::key}{'window'}) ? ' target="_blank"' : '') . (($article{$id}{'site'}) ? ' title="' . $this->escape_without_html_entity($article{$id}{'site'}) . '"' : '') . '>' . $this->escape($article{$id}{'link'}) . '</a>' : '';
		$temp =~ s/<\!--link(?!\w)([^>]*)-->(.*?)<\!--\/link(?!\w)[^>]*-->/$this->item_tag_replace('link',$1,$2,$link)/ges;
		$is_linked = 1;
	}
	$temp =~ s/<\!--mtime(?!\w)([^>]*)-->(.*?)<\!--\/mtime-->/$this->date_replace($article{$id}{'mtime'},$1,$2,0,(($is_linked || !$article{$id}{'link'}) ? () : ($article{$id}{'link'},(($article{$id}{'site'}) ? $article{$id}{'site'} : ''),$setting::page{$setting::key}{'window'},$setting::general{'nofollow'})))/sge;
	$temp =~ s/<\!--date(?!\w)([^>]*)-->(.*?)<\!--\/date-->/$this->date_replace($article{$id}{'mtime'},$1,$2,1,(($is_linked || !$article{$id}{'link'}) ? () : ($article{$id}{'link'},(($article{$id}{'site'}) ? $article{$id}{'site'} : ''),$setting::page{$setting::key}{'window'},$setting::general{'nofollow'})))/sge;
	$temp =~ s/<\!--author(?!\w)([^>]*)-->(.*?)<\!--\/author(?!\w)[^>]*-->/$this->item_tag_replace('author',$1,$2,$article{$id}{'author'})/ges if $required{'author'};
	if ($required{'description'}) {
		my $description = $this->autolink($article{$id}{'description'},1,1);
		if ($article{$id}{'site_url'} && $article{$id}{'site'} =~ m!Twitter\s*/\s*(.*)$!i) {
			my $name = $1;
			my $link_attributes = (($setting::general{'nofollow'}) ? ' rel="nofollow"' : '') . (($setting::page{$setting::key}{'window'}) ? ' target="_blank"' : '');
			my $site ='<strong><a href="' . $this->escape($article{$id}{'site_url'}) . '"' . $link_attributes . '>' . $name . '</a></strong>';
			$description =~ s/^$name:/$site/;
			$description =~ s!\@(\w+)!\@<a href="http://twitter.com/$1"$link_attributes>$1</a>!g;
			$description =~ s!\#(\w+)(?=(?:\s|$))!<a href="http://search.twitter.com/search?q=%23$1"$link_attributes>#$1</a>!g;
			$description =~ s!\#(\S+_)(?=(?:\s|$))!'<a href="http://search.twitter.com/search?q=%23' . $this->url_encode($this->jcode_convert($1,'utf8','euc')) . '"' . $link_attributes . '>#' . $1 . '</a>'!eg;
		}
		$temp =~ s/<\!--description(?!\w)([^>]*)-->(.*?)<\!--\/description(?!\w)[^>]*-->/$this->item_tag_replace('description',$1,$2,$description)/ges;
	}
	$temp =~ s/<\!--content(?!\w)([^>]*)-->(.*?)<\!--\/content(?!\w)[^>]*-->/$this->item_tag_replace('content',$1,$2,$article{$id}{'content'})/ges if $required{'content'};
	$list .= $temp;
}
$template =~ s/<\!--article--><\!--\/article-->/$this->item_tag_replace('article','','',$list)/ges;
if ($mkfile_flag) {
	my $mklist = $ENV{'SCRIPT_NAME'};
	$mklist =~ s/start.cgi$/mklist.cgi/;
	$template .= '<img src="' . $mklist . '" width="1" height="1" />' if $template !~ /<img[^>]+src="$mklist"[^>]*>/i;
}
print OUT $template;
$this->print_page_footer($setting::key,\*OUT) if !$main::mode;
close (OUT);
$this->mk_external_javascript($cache_file);

#ڡեå
if ($mkfile_flag) {
	$this->print_invisible_gif;
} else {
	$cache_file = $default::preference_dir . '/ssi_cache.js' if defined $main::mode && $main::mode eq 'js';
	$this->print_cache($cache_file);
}
}

sub is_not_required($$$$) {
my($this,$article,$required_words,$ignore_words) = @_;
return 0 if !@$required_words && !@$ignore_words;
my @data = map($this->z_to_h($_,'euc'),($article->{'title'},$article->{'description'},$article->{'content'},$article->{'author'}));
my $is_matched = 0;
if (@$required_words) {
	foreach my $w (@$required_words) {
		if (grep(eval{$_ =~ /$w/i},@data)) {
			if ($setting::general{'requiredWordsMethod'} && $setting::general{'requiredWordsMethod'} eq 'and') {
				return 1;
			} else {
				$is_matched = 1;
			}
		}
	}
	return 1 if !$is_matched;
}
if (@$ignore_words) {
	$is_matched = 1;
	foreach my $w (@$ignore_words) {
		if (grep(eval{$_ =~ /$w/i},@data)) {
			if ($setting::general{'ignoreWordsMethod'} && $setting::general{'ignoreWordsMethod'} ne 'and') {
				return 1;
			}
		} else {
			$is_matched = 0;
		}
	}
	return $is_matched;
} else {
	return 0;
}
}

sub get_atom_value ($$$$) {
my($this,$element,$type,$name) = @_;
return '' if !defined $element;
$element = [$element] if !ref $element || ref $element ne 'ARRAY';
foreach my $this_element (@$element) {
	if (defined $this_element->{'type'} && $this_element->{'type'} =~ /$type/ && defined $this_element->{$name}) {
		return $this_element->{$name};
	}
}
return '';
}

######################################################################
sub date_replace ($$;$$$$$) {
my($this,$gmt,$attributes,$content,$date,$link,$title,$newwindow,$nofollow) = @_;
my $type = ($attributes && $attributes =~ /\s+type="([^"]+)"/s) ? $1 : $setting::general{'datetype'};
my $format = '';
if ($content =~ s/\s*<\!--format(?!\w)[^>]*-->(.*?)<\!--\/format(?!\w)[^>]*-->//si) {
	$format = $1;
	$attributes .= ' format="' . $this->lf_to_entity($this->escape($format)) . '"' unless $attributes =~ s/(\s+format\s*=\s*")[^"]*(")/$1 . $this->lf_to_entity($this->escape($format)) . $2/gesi;
} elsif ($attributes =~ /\s+format\s*=\s*"([^"]+)"/si) {
	$format = $this->unescape($this->entity_to_lf($1));
}
my($header,$footer) = $this->get_header_and_footer($attributes,$content);
$type .= '>d' if $date;
$type = 'gmt' . $type if $type !~ /gmt/;
return $header . (($link) ? '<a href="' . $this->escape($link) . '"' . (($title) ? ' title="' .  $this->escape_without_html_entity($title) . '"' : '') . (($nofollow) ? ' rel="nofollow"' : '') . (($newwindow) ? ' target="_blank"' : '') . '>' : '') . $this->date($gmt,0,$type,$format) . (($link) ? '</a>' : '') . $footer;
}

sub date_to_gmt ($$) {
my($this,$date) = @_;
my($year,$mon,$mday,$hour,$min,$sec,$tz);
if ($date =~ /(\d{4}|\d{2})-(\d{1,2})-(\d{1,2})T(\d{2}):(\d{2})(?::(\d{2}))?(?:\.\d+)?(UT|GMT|[ECMP][SD]T|[A-Z]|[+\-]\d{2}\:?\d{2})/) {
	($year,$mon,$mday,$hour,$min,$sec,$tz) = ($1,$2,$3,$4,$5,$6,$7);
} elsif ($date =~ /(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun), )?(\d{1,2}) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) (\d{4}|\d{2}) (\d{2}):(\d{2})(?::(\d{2}))? (UT|GMT|[ECMP][SD]T|[A-Z]|[+\-]\d{2}\:?\d{2})/) {
	($year,$mon,$mday,$hour,$min,$sec,$tz) = ($4,$3,$2,$5,$6,$7,$8);
	my %monthes = qw(Jan 1 Feb 2 Mar 3 Apr 4 May 5 Jun 6 Jul 7 Aug 8 Sep 9 Oct 10 Nov 11 Dec 12);
	$year = ($year < 70) ? $year + 2000 : ($year < 1000) ? $year + 1900 : $year;
	$mon = $monthes{$mon};
} else {
	return time;
}
if ($tz && $tz =~ /[A-Z]/) {
	my %timezones = (
		'UT' => '+0000', 'GMT' => '+0000', 'EST' => '-0500', 'EDT' => '-0400', 'CST' => '-0600', 'CDT' => '-0500', 'MST' => '-0700', 'MDT' => '-0600', 'PST' => '-0800', 'PDT' => '-0700', 
		'A' => '-0100', 'B' => '-0200', 'C' => '-0300', 'D' => '-0400', 'E' => '-0500', 'F' => '-0600', 'G' => '-0700', 'H' => '-0800', 'I' => '-0900', 'K' => '-1000', 'L' => '-1100', 'M' => '-1200', 'N' => '+0100', 'O' => '+0200', 'P' => '+0300', 'Q' => '+0400', 'R' => '+0500', 'S' => '+0600', 'T' => '+0700', 'U' => '+0800', 'V' => '+0900', 'W' => '+1000', 'X' => '+1100', 'Y' => '+1200'
	);
	$tz = $timezones{$tz};
} else {
	$tz =~ s/://;
}
$tz = ($tz && $tz =~ /([+\-])(\d{2})(\d{2})/) ? $1 . $2 * 3600 + $3 * 60 : 0;
return timegm($sec,$min,$hour,$mday,($mon-1),$year) - $tz;
}

######################################################################
sub print_invisible_gif ($) {
my $this = shift;
print 'Content-type: image/gif',"\x0A";
print 'Content-length: 43',"\x0A";
#print 'Cache-Control: no-cache',"\x0A";
#print 'Pragma: no-cache',"\x0A";
print "\x0A";
print "GIF89a\x01\x00\x01\x00\x80\x00\x00\xFF\xFF\xFF\x00\x00\x00\x21\xF9\x04\x05\x14\x00\x00\x00\x2C\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02\x02D\x01\x00\x3B";
}

######################################################################
sub print_cache ($$) {
my($this,$path) = @_;
local(*FILE);
if (open(FILE, $path)) {
	binmode FILE;
	flock(FILE, LOCK_SH);
	while (<FILE>) {
		print;
	}
	close (FILE);
}
}

######################################################################
sub unauthorized_alert ($) {
my $this = shift;
if ($main::m) {
	if ($main::mode && ($main::mode eq 'ssi' || $main::mode eq 'js')) {
		$this->print_http_header('text/javascript');
	} else {
		$this->print_password_check_form($setting::key);
	}
} else {
	$this->write_file($default::file,'',1);
	$this->write_file($default::file,'',1) if $default::file =~ s/\.ssi$/.js/;
	$this->print_invisible_gif;
}
exit;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	#DBɤ߹
	$setting::general = 1 if !$setting::general;					#ɤ߹
	$setting::deco = 1 if !$setting::deco;						#ƥɤ߹
	$setting::security = 1 if !$setting::security;					#ɤ߹
	$setting::page = 1 if !$setting::page;						#ڡɤ߹

	#省
	undef $main::mode if !$main::mode || ($main::mode ne 'ssi' && $main::mode ne 'js');
	$setting::security_key = 'feed';			#ǥեȥƥ
	if ($main::mode) {
		$setting::key = 'ssi';
	} else {
		$setting::key = 'feed';
	}

	#å
	$cookie::id_enabled = 1 if !$cookie::id_enabled;							#ID󥯥åɤ߹

	#ǥեȥ
	$main::k = 'feed' if !defined $main::k || !$main::k;

	#ɬܥե
	@setting::form = ('m','k') if !@setting::form;

	#饹Ͽ
	Common::class_register('feed','FeedMixer');
}

1;
