package MConv;
require CMONOS::CGI_Lib::Common;
@ISA = qw(Common);
use strict;
use Jcode;
use Time::Local;
use Fcntl qw(:flock);
######################################################################
# 췿ӸƥѴ⥸塼 cmonos.m
# OutdatedMobile/Conv.pm ver1.1.0
# Copyright (C) 2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-09-01
######################################################################
#֥Ⱥ
sub new ($$$$) {
my($pkg,$store,$skippable_elements,$postponable_elements,$parsable_tables,$target,$ignore,$lifetime,$use_trans_sid,$prev,$next) = @_;
my $this = {
	'store' => ($store || './cookies'),
	'skippable_elements' => ((ref $skippable_elements) ? $skippable_elements : []),
	'postponable_elements' => ((ref $postponable_elements) ? $postponable_elements : []),
	'parsable_tables' => ((ref $parsable_tables) ? $parsable_tables : []),
	'target_domain' => ((ref $target) ? $target : []),
	'ignorable_url' => ((ref $ignore) ? $ignore : []),
	'lifetime' => ($lifetime || 14),
	'use_trans_sid' => ($use_trans_sid || 0),
	'prev_text' => ($prev || ' &lt;&lt;PREV '),
	'next_text' => ($next || ' NEXT&gt;&gt; '),
};
bless $this;
$this;
}

######################################################################
# ¹
sub run ($) {
my $this = shift;
require CMONOS::CGI_Lib::HTTP_Client;
$HTTP_Client::UserAgent = $ENV{'HTTP_USER_AGENT'} . ' MCONV' || 'MCONV';

# ̵뤹(id|tagName?.className)
my @skippable_elements = @{$this->{'skippable_elements'}};

# 󤷤ˤ(id|tagName?.className)
my @postponable_elements = @{$this->{'postponable_elements'}};

# ʬ򤹤ơ֥(id|.className)
my @parsable_tables = @{$this->{'parsable_tables'}};

# ڡʬ
my $prev_text = $this->{'prev_text'};
my $next_text = $this->{'next_text'};

if (ref $this->{'ignorable_url'} && @{$this->{'ignorable_url'}}) {
	my @temp = ();
	foreach my $ig (@{$this->{'ignorable_url'}}) {
		$ig = $this->full_path($ig) unless $ig =~ s/^(https?:\/\/[^\/]+)(.*?)$/lc($1) . $2/ei;
		push(@temp,$ig);
	}
	@{$this->{'ignorable_url'}} = @temp;
}

# 桼üID
my $user_id;
my $is_secure_user = 0;
my $autobreak = 1;
my $break_disabled = 0;
my $maxsize = 29000;
my %access_key_icon = ();
my $caution_icon = '';
my $mail_icon = '';
my $tel_icon = '';
my $salt = 'mB';
if ($ENV{'HTTP_USER_AGENT'} =~ m!https?://!i) {
	$this->{'carrier'} = 'pc';
	$this->{'is_bot'} = 1 
} elsif ($ENV{'HTTP_USER_AGENT'} =~ m!^DoCoMo/(\d+\.?\d*)!i) {		# DoCoMo
	$maxsize = 4000 if $1 < 2;
	if ($ENV{'HTTP_X_DCMGUID'}) {
		$user_id = $ENV{'HTTP_X_DCMGUID'};
		if ($ENV{'REMOTE_HOST'} && $ENV{'REMOTE_HOST'} =~ /\.docomo\.ne\.jp$/i) {
			$is_secure_user = 1;
			$salt = 'Im';
		}
	}
	$this->{'carrier'} = 'docomo';
	%access_key_icon = (
		'0' => '&#xE6EB;',
		'1' => '&#xE6E2;',
		'2' => '&#xE6E3;',
		'3' => '&#xE6E4;',
		'4' => '&#xE6E5;',
		'5' => '&#xE6E6;',
		'6' => '&#xE6E7;',
		'7' => '&#xE6E8;',
		'8' => '&#xE6E9;',
		'9' => '&#xE6EA;',
#		'0' => "\xF9\x86",
#		'1' => "\xF9\x87",
#		'2' => "\xF9\x88",
#		'3' => "\xF9\x89",
#		'4' => "\xF9\x8A",
#		'5' => "\xF9\x8B",
#		'6' => "\xF9\x8C",
#		'7' => "\xF9\x8D",
#		'8' => "\xF9\x8E",
#		'9' => "\xF9\x8F",
	);
	$caution_icon = '&#xE737;';
	$mail_icon = '&#xE6CF;';
	$tel_icon = '&#xE6CE;';
} elsif ($ENV{'HTTP_USER_AGENT'} =~ /(?:KDDI|UP\.Browser)/i) {		# au
	$maxsize = 8000;
	if ($ENV{'HTTP_X_UP_SUBNO'}) {
		$user_id = $ENV{'HTTP_X_UP_SUBNO'};
		if ($ENV{'REMOTE_HOST'} && $ENV{'REMOTE_HOST'} =~ /(?:\.ezweb\.ne\.jp|\.ido\.ne\.jp|\.kddi\.ne\.jp|\.brew\.ne\.jp)$/i) {
			$is_secure_user = 1;
			$salt = 'eZ';
		}
	}
	$this->{'carrier'} = 'au';
	%access_key_icon = (
		'0' => '<img localsrc="325" alt="[0]" border="0">',
		'1' => '<img localsrc="180" alt="[1]" border="0">',
		'2' => '<img localsrc="181" alt="[2]" border="0">',
		'3' => '<img localsrc="182" alt="[3]" border="0">',
		'4' => '<img localsrc="183" alt="[4]" border="0">',
		'5' => '<img localsrc="184" alt="[5]" border="0">',
		'6' => '<img localsrc="185" alt="[6]" border="0">',
		'7' => '<img localsrc="186" alt="[7]" border="0">',
		'8' => '<img localsrc="187" alt="[8]" border="0">',
		'9' => '<img localsrc="188" alt="[9]" border="0">',
	);
	$caution_icon = '<img localsrc="1" alt="[!]" border="0">';
	$mail_icon = '<img localsrc="108" alt="[Mail]" border="0">';
	$tel_icon = '<img localsrc="155" alt="[Tel]" border="0">';
} elsif ($ENV{'HTTP_USER_AGENT'} =~ /(?:J-PHONE|Vodafone|SoftBank)/i) {		# Softbank
	if ($ENV{'HTTP_USER_AGENT'} =~ m!^J-PHONE/(\d+\.?\d*)!i) {
		my $ver = $1 + 0;
		$maxsize = ($ver < 4) ? 5000 : ($ver <= 4.2) ? 11000 : 29000;
	}
	if ($ENV{'HTTP_USER_AGENT'} =~ /\/SN([0-9a-zA-Z]+)/) {
		$user_id = $1;
		if ($ENV{'REMOTE_HOST'} && $ENV{'REMOTE_HOST'} =~ /(?:\.jp-k\.ne\.jp|\.jp-c\.ne\.jp|\.jp-t\.ne\.jp|\.jp-q\.ne\.jp|\.softbank\.ne\.jp)$/i) {
			$is_secure_user = 1;
			$salt = 'yM';
		}
	}
	$this->{'carrier'} = 'softbank';
	%access_key_icon = (
		'0' => '&#xE225;',
		'1' => '&#xE21C;',
		'2' => '&#xE21D;',
		'3' => '&#xE21E;',
		'4' => '&#xE21F;',
		'5' => '&#xE220;',
		'6' => '&#xE221;',
		'7' => '&#xE222;',
		'8' => '&#xE223;',
		'9' => '&#xE224;',
	);
	$caution_icon = '&#xE252;';
	$mail_icon = '&#xE103;';
	$tel_icon = '&#xE104;';
} else {
	$this->{'carrier'} = 'pc';
	$autobreak = 0;
}
$user_id = $this->get_guid($user_id,$salt);
$this->{'query_string'} = $ENV{'QUERY_STRING'} || '';
$this->{'query_string'} =~ s/&?guid=ON(?=(?:&|$))//;
if ($this->{'query_string'} =~ s/&?MCONV_SESSION_ID=([^&=]+)(?=(?:&|$))//) {
	my $sid = $this->session_decode($1);
	$this->{'session_id'} = $sid;
}
$this->{'query_string'} =~ s/^&//;
$this->{'query_string'} = '?' . $this->{'query_string'} if $this->{'query_string'} ne '';
my $session_id = $this->session_decode($this->read_cookie_direct('MCONV_SESSION_ID'));
if (!$this->{'use_trans_sid'} && $user_id) {
	if ($session_id) {
		if (-f $this->{'store'} . '/' . $user_id) {
			$session_id = 'm.' . $this->unique_id;
			rename($this->{'store'} . '/' . $user_id,$this->{'store'} . '/' . $session_id);
			$this->{'session_id'} = $session_id;
		} elsif ($this->{'session_id'} && -f $this->{'store'} . '/' . $this->{'session_id'}) {
			$session_id = 'm.' . $this->unique_id;
			rename($this->{'store'} . '/' . $this->{'session_id'},$this->{'store'} . '/' . $session_id);
			$this->{'session_id'} = $session_id;
		} elsif (-f $this->{'store'} . '/' . $session_id) {
			$this->{'session_id'} = $session_id;
		} else {
			$this->{'session_id'} = 'm.' . $this->unique_id;
		}
		$this->{'use_trans_sid'} = $this->{'cookie_enabled'} = 1;
	} elsif ($this->{'session_id'} && -f $this->{'store'} . '/' . $this->{'session_id'}) {
		rename($this->{'store'} . '/' . $this->{'session_id'},$this->{'store'} . '/' . $user_id);
		$this->{'session_id'} = $user_id;
	} else {
		$this->{'session_id'} = $user_id;
	}
} else {
	$this->{'use_trans_sid'} = 1;
	if ($session_id) {
		if ($this->{'session_id'} && -f $this->{'store'} . '/' . $this->{'session_id'}) {
			$session_id = 'm.' . $this->unique_id;
			rename($this->{'store'} . '/' . $this->{'session_id'},$this->{'store'} . '/' . $session_id);
			$this->{'session_id'} = $session_id;
		} elsif (-f $this->{'store'} . '/' . $session_id) {
			$this->{'session_id'} = $session_id;
		} else {
			$this->{'session_id'} = 'm.' . $this->unique_id;
		}
		$this->{'cookie_enabled'} = 1;
	} elsif (!$this->{'session_id'}) {
		$this->{'session_id'} = 'm.' . $this->unique_id;
	}
}
$this->{'target_url'} = $ENV{'PATH_INFO'} || '';
my $p = ($this->{'target_url'} =~ s/\.P(\d+)$// && $1) ? $1+0 : 1;
$this->{'target_url'} .= '/' if $this->{'target_url'} =~ m!/[^\./]+$!;
if ($this->{'target_url'} =~ s!^/(?=\.\./)!!) {
	$this->{'target_url'} = $this->full_path($this->{'target_url'});
} else {
	$this->{'target_url'} =~ s!^/(https?:)//?!$1//!g;
}
my $my_url = $this->{'here'} = $this->my_url;
$this->{'here'} =~ s!/[\w\.]+$!!;
if ($this->{'target_url'} =~ m!^https?://([^/]+)!i) {
	if ($this->is_not_target_domain($1)) {
		$this->get_cookie_by_uid($user_id);
		$this->save_cookie_by_uid('',$user_id,1);
		$this->set_cookie_direct($this->{'lifetime'},'MCONV_SESSION_ID',(($this->{'use_trans_sid'}) ? $this->{'session_id'} : 'm.' . $this->unique_id),$this->to_host($ENV{'SERVER_NAME'}),$ENV{'SCRIPT_NAME'});
		$this->print_http_header;
		print '<html><head><meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS"><title>';
		print $cgi::Jcode->set('̤ΥȤ˰ư褦ȤƤޤ')->sjis;
		print '</title></head><body>';
		my $jumpto = $this->escape($this->{'target_url'} . $this->{'query_string'});
		print '<p><a href="' . $jumpto . '" ' . (($this->{'carrier'} eq 'softbank') ? 'nonumber directkey' : 'accesskey') . '="1">' . ($access_key_icon{'1'} || '') . $jumpto . '</a></p>';
		print '<p><font size="2">' . $caution_icon;
		print $cgi::Jcode->set('̤ΥȤذư褦ȤƤޤư PC ѥȤβǽޤưϾ嵭󥯤򥯥åƤ')->sjis;
		print '</font></p>';
		print '<center><p><font size="2"><a href="' . $this->m_url($this->{'referer_url'}) . '" ' . (($this->{'carrier'} eq 'softbank') ? 'nonumber directkey' : 'accesskey') . '="0">' . ($access_key_icon{'0'} || '');
		print $cgi::Jcode->set('')->sjis;
		print '</a></font></p>';
		print '</center></body></html>';
		return;
	}
	$this->{'self_path'} = $ENV{'SCRIPT_NAME'} . '/' . $this->{'target_url'};
	$this->{'self_path'} =~ s!/+!/!g;
} else {
	$this->{'target_url'} =~ s!^\./!/!;
	$this->{'target_url'} = '/' if !$this->{'target_url'};
	$this->{'self_path'} = $ENV{'SCRIPT_NAME'} . $this->{'target_url'};
	$this->{'target_url'} = $this->{'here'} . $this->{'target_url'};
}
$this->jump($this->{'target_url'} . $this->{'query_string'}) if $this->is_not_target_url($this->{'target_url'});
($this->{'current_domain'},$this->{'current_path'}) = ($this->{'target_url'} =~ /^(https?:\/\/[^\/]+)(.*?)$/i) ? (lc $1,$2) : ('','/');
$this->{'is_out_of_domain'} = 1 if $this->{'current_domain'} ne $this->http_my_domain;
my %header = ();
my $content = '';
my $msg = '';
if ($ENV{'REQUEST_METHOD'} eq "POST") {
	read(STDIN, $content, $ENV{'CONTENT_LENGTH'});
	$header{'Content-Type'} = $ENV{'CONTENT_TYPE'} || 'application/x-www-form-urlencoded';
	$break_disabled = 1;
}
my($account,$password);
if ($ENV{'HTTP_AUTHORIZATION'} && $ENV{'HTTP_AUTHORIZATION'} =~ /^\s*Basic\s+([A-Za-z0-9\+\/=]+)/is) {
	($account,$password) = split(/:/,HTTP_Client->new->base64_to_data($1));
	$this->{'is_authorized'} = 1;
}
if ($this->{'target_url'} !~ /\.(?:gif|jpg|jpeg|png|mp3|amc|3g2|3gp|mp4|m4v|m4a|wmv|mov)$/i) {
	my $cookies = $this->get_cookie_by_uid($user_id);
	$header{'Cookie'} = $cookies if $cookies;
}
$this->{'referer_url'} = $ENV{'HTTP_REFERER'} if $ENV{'HTTP_REFERER'} && $ENV{'HTTP_REFERER'} !~ /^$my_url/;
$header{'Referer'} = $this->{'referer_url'} if $this->{'referer_url'};
$header{'Accept'} = 'text/html, application/xhtml+xml';
my $res = HTTP_Client->new->requests_redirectable_if(sub ($$;$) {
	my($method,$url,$res) = @_;
	if ($url) {
		my $set_cookie = $res->header('Set-Cookie');
		my $domain = ($url =~ m!^https?://([^/]+)!i) ? $1 : '';
		if (($url =~ /^$this->{'here'}/ || ($domain && !$this->is_not_target_domain($domain))) && !$this->is_not_target_url($url)) {
			$this->{'target_url'} = $url;
			$url =~ s!^$this->{'here'}!$this->{'here'}/m.cgi!;
		}
		print "Location: $url\n";
		print 'Set-Cookie: ' . $set_cookie . "\n" if $set_cookie;
		print "\n";
		exit;
	}
})->request(($ENV{'REQUEST_METHOD'} || 'GET') => $this->{'target_url'} . $this->{'query_string'},\%header,$content,'',1000000,'',$account,$password);
undef $content;
undef %header;

my $content_type = $res->header('Content-Type');
if ($res->code eq '401') {
	print 'WWW-Authenticate: ' . $res->header('WWW-Authenticate') . "\x0A" if $res->header('WWW-Authenticate');
	print "Status: 401 Unauthorized\x0A";
	print "Content-Type: text/html\x0A\x0A";
	print '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">' . "\x0A";
	print '<html><head><meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS"><title>';
	print $cgi::Jcode->set('ǧڤ˼Ԥޤ')->sjis;
	print '</title></head><body>';
	print '<p><font size="2">' . $caution_icon;
	print $cgi::Jcode->set('ǧڤ˼Ԥޤ')->sjis;
	print '</font></p>';
	print '</body></html>';
	return;
} elsif (!$res->is_success) {
	my $not_found = ($res->code eq '404') ? 1 : 0;
	$this->print_http_header;
	print '<html><head><meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS"><title>';
	print $cgi::Jcode->set(($not_found) ? 'ե뤬ߤĤޤǤ' : 'URLɽŬʤǽޤ')->sjis;
	print '</title></head><body>';
	if ($not_found) {
		print '<p><font size="2">' . $caution_icon;
		print $cgi::Jcode->set('ե뤬ߤĤޤǤ')->sjis;
		print '</font></p>';
	} else {
		my $size = $res->header('Content-Length');
		my $jumpto = $res->url || $this->escape($this->{'target_url'} . $this->{'query_string'});
		print '<p><a href="' . $jumpto . '" ' . (($this->{'carrier'} eq 'softbank') ? 'nonumber directkey' : 'accesskey') . '="1">' . ($access_key_icon{'1'} || '') . $jumpto . '</a></p>';
		print '<p><font size="2">' . $caution_icon;
		print $cgi::Jcode->set('URLɽŬʤǽޤ' . (($content_type) ? '(' . $content_type . ')' : '') . (($size) ? '[' . $size . 'byte]' : '') . 'Ͼ嵭󥯤򥯥åƤ')->sjis;
		print '</font></p>';
	}
	if ($this->{'referer_url'}) {
		print '<center><p><font size="2"><a href="' . $this->m_url($this->{'referer_url'}) . '" ' . (($this->{'carrier'} eq 'softbank') ? 'nonumber directkey' : 'accesskey') . '="0">' . ($access_key_icon{'0'} || '');
		print $cgi::Jcode->set('')->sjis;
		print '</a></font></p></center>';
	}
	print '</body></html>';
	return;
} elsif ($content_type !~ /html/i) {
	print 'Content-Type: ' . $content_type . "\x0A";
	print "\x0A";
	print($res->content() || '');
	return;
}

my @cookies = $res->header('Set-Cookie');
$this->save_cookie_by_uid(\@cookies,$user_id);
$this->set_cookie_direct($this->{'lifetime'},'MCONV_SESSION_ID',(($this->{'use_trans_sid'}) ? $this->{'session_id'} : 'm.' . $this->unique_id),$this->to_host($ENV{'SERVER_NAME'}),$ENV{'SCRIPT_NAME'});
$this->print_http_header;
my $html = $res->content('euc');
undef $res;
$html =~ s/[\x20\x09]+/\x20/gs;
my $title = ($html =~ /<title(?!\w)[^>]*?>(.*?)<\/title>/is) ? $cgi::Jcode->set($1)->sjis : '';
my $canonical = $this->{'target_url'};
if ($html =~ /<link(?!\w)([^>]*?rel=['"]?canonical['"]?[^>]*?)>/is) {
	my $link = $1;
	$canonical = $1 if $link =~ /\shref=['"]?([^\s"']+)/si;
}
my($hrcolor,$hrsize);
$html =~ s/<!--m:content(?!\w)\s?(.*?)-->/$1/igs;
while ($html =~ /<!--m:config(?=\s)(.*?)-->/igs) {
	my $config = $1;
	@skippable_elements = split(/\s*,\s*/,$this->unescape($1)) if $config =~ /\sskippable="([^"]*)"/is;
	push(@skippable_elements,split(/\s*,\s*/,$this->unescape($1))) if $config =~ /\sskippable\+="([^"]*)"/is;
	@postponable_elements = split(/\s*,\s*/,$this->unescape($1)) if $config =~ /\spostponable="([^"]*)"/is;
	push(@postponable_elements,split(/\s*,\s*/,$this->unescape($1))) if $config =~ /\spostponable\+="([^"]*)"/is;
	@parsable_tables = split(/\s*,\s*/,$this->unescape($1)) if $config =~ /\sparsable="([^"]*)"/is;
	push(@parsable_tables,split(/\s*,\s*/,$this->unescape($1))) if $config =~ /\sparsable\+="([^"]*)"/is;
	$prev_text = $this->unescape($1) if $config =~ /\sprev="([^"]*)"/is;
	$next_text = $this->unescape($1) if $config =~ /\snext="([^"]*)"/is;
	$hrcolor = $1 if $config =~ /\shrcolor="(\#?\w+)"/is;
	$hrsize = $1 if $config =~ /\shrsize="(\d+)"/is;
	$autobreak = 0 if $config =~ /\sautobreakdisabled(?=(?:\s|="[^"]*"|$))/is;
}
my $separator = '<hr' . (($hrcolor) ? ' color="' . $hrcolor . '"' : '') . (($hrsize) ? ' size="' . $hrsize . '"' : '') . '>';
my %body;
my $body_attributes = '';
while ($html =~ /<!--m:body(?=\s)(.*?)-->/igs) {
	my $attributes = $1;
	while ($attributes =~ /\s(\w+)="([^"]*)"/sg) {
		$body{$1} = $this->escape_without_html_entity($2);
	}
}
if (%body) {
	while (my($k,$v) = each %body) {
		$body_attributes .= ' ' . $k . '="' . $v . '"';
	}
}
undef %body;
$html =~ s/<script(?!\w)([^>]*?)>.*?<\/script>/$this->sim_ssi($1)/egis;
$html =~ s/<script(?!\w)([^>]*?)>.*?<\/script>//gis;
$html =~ s/<applet(?!\w)([^>]*?)>.*?<\/applet>//gis;
$html =~ s/<style(?!\w)([^>]*?)>.*?<\/style>//gis;
$html =~ s/<canvas(?!\w)([^>]*?)>.*?<\/canvas>//gis;
$html =~ s/<(video|audio|object|embed)(?!\w)([^>]*?)>(.*?)<\/\1>/$this->object_link($2,$3)/egis;
$html =~ s/<embed(?!\w)([^>]*?)>/$this->object_link($1)/egis;
$html =~ s/<!--(?!m:pagebreak).*?-->//igs;
$html =~ s/<(div|span)(?!\w)[^>]*?><\/\1>//gis;
if ($html =~ /<base(?!\w)[^>]*\shref=['"]([^\s'"]+)[^>]*?>/is) {
	my $base_href = $1;
	if ($base_href =~ m!^$this->{'here'}!) {
		$this->{'target_url'} = $base_href;
	} else {
		if ($base_href =~ /^https?:\/\/[^\/]+(.*?)$/i) {
			$this->{'target_url'} = $base_href;
		} elsif ($base_href =~ /^\./) {
			$this->{'target_url'} = $this->{'current_domain'} . $this->path_change($base_href,$this->{'current_path'},'abs');
		}
	}
	$this->{'target_url'} .= '/' if $this->{'target_url'} =~ m!/[^\./]+$!;
}
if ($html =~ /<body(?!\w)([^>]*?)>/is) {
	my $alert = $1;
	my $list = '';
	while ($alert =~ /alert\(['"]([^'"]+)['"]\)/g) {
		$list .= '<li>' . $1 . '</li>'; 
	}
	$msg .= '<ul>' . $list . '</ul>' . $separator if $list; 
}
$msg = $cgi::Jcode->set($msg)->sjis;
print <<HEAD;
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
<link rel="canonical" href="$canonical">
<title>$title</title>
</head>
<body$body_attributes>$msg
HEAD
my $page_count = 1;
my $pagesize = 0;
my $postponable_html = '';
my $skippable = 0;
my $postponable = 0;
my $parsable = 0;
my $simpleparsable = 0;
my $col = 0;
my $is_th = 0;
my $table_start = 0;
my $in_form = 0;
my @th = ();
my $in_anchor = 0;
my $in_thead = 0;
my @open_tags = ();
my $continual_separator = 0;
my %font_size = ('x-small' => 1, 'small' => 2, 'medium' => 3, 'large' => 4, 'x-large' => 5, 'xx-large' => 6);
my %access_key;
my @access_keys = (0..9,'*','#');
my $sc_name_cell = 0;
if ($html =~ /<frameset(?!\w)[^>]*?>/is) {
	print '<ul>';
	while ($html =~ /<frame(?!\w)([^>]+)>/isg) {
		my $attributes = $1;
		my $src = $this->escape_without_html_entity($1) if $attributes =~ /\ssrc="([^"]*)"/is;
		my $title = ($attributes =~ /\stitle="([^"]*)"/is || $attributes =~ /\salt="([^"]*)"/is || $attributes =~ /\sname="([^"]*)"/is) ? $this->escape_without_html_entity($1) : 'ե졼';
		print '<li>' . $this->m_anchor($src) . $title . '</a></li>';
	}
	print '</ul>';
}
$html = $1 if $html =~ /<body(?!\w)[^>]*?>(.*?)(?:<\/body>|<\/html>|$)/is;
while ($html =~ /\G(<!--m:pagebreak(?!\w).*?-->|<(\/?)(\w+)(?!\w)([^>]*?)\s*\/?>|[^><]+)/isg) {
	my($buf,$closed,$tag,$attributes) = ($1,$2,lc $3,$4);
	my $is_empty = 0;
	my $is_changed = 0;
	my $ignore = 0;
	my %attributes_hash = ();
	if ($tag) {
		if (!$break_disabled && $autobreak && !$in_form && !$closed && $pagesize > $maxsize) {
			last if $this->page_break($p,\$page_count,\@open_tags,$prev_text,$next_text);
			$continual_separator = $pagesize = 0;
		}
		my $head = '';
		my $foot = '';
		my $original_tag = $tag;
		if (!$closed) {
			while ($attributes =~ /\s(\w+)="([^"]*)"/sg) {
				$attributes_hash{lc $1} = $this->escape_without_html_entity($2);
			}
			foreach my $name ('multiple','selected','checked') {
				$attributes_hash{$name} = $name if $attributes =~ /\s$name(?!\w)/i;
			}
		}
		$attributes = '';
		if ($tag eq 'thead') {
			if ($table_start && !$parsable) {
				push(@th,[]);
				$simpleparsable = 1;
			}
			$in_thead = (!$closed) ? 1 : 0;
			$table_start = 0;
			next;
		} elsif (grep($_ eq $tag,'iframe','figure','figcaption','tbody','thead','tfoot','meta','link','spacer','video','audio','object','embed','param','source','bgsound','noscript')) {
			next;
		} elsif (grep($_ eq $tag,'nav','section','article','header','footer','details','caption')) {
			$tag = 'div';
		} elsif (grep($_ eq $tag,'br','hr','li','dt','dd','area','option')) {
			$is_empty = 1;
		} elsif ($tag eq 'strong') {
			$tag = 'b';
		} elsif ($tag eq 'em') {
			$tag = 'i';
		} elsif ($tag eq 'del') {
			$tag = 'strike';
		} elsif ($tag eq 'span') {
			$tag = 'font';
			if (!$closed && $attributes_hash{'style'}) {
				$attributes_hash{'color'} = $1 if $attributes_hash{'style'} =~ /(?:^|[;\s])color:\s*(\#?\w+)/is;
				$attributes_hash{'size'} = $font_size{$1} if $attributes_hash{'style'} =~ /font-size:\s*([\w\-]+)/is && $font_size{$1};
			}
		} elsif ($tag eq 'img') {
			$is_empty = 1;
			if (!$closed) {
				if ($attributes_hash{'src'} && $attributes_hash{'src'} =~ m!(?:/accestat/stat.cgi|/accesscounter/counter.cgi)(\?|$)!) {
					$attributes_hash{'src'} .= $this->escape((($1) ? '&' : '?') . 'url=' . $this->url_encode($this->{'target_url'} . $this->{'query_string'}) . (($attributes_hash{'src'} =~ m!/accestat/stat.cgi(\?|$)!) ? '&referer=' . $this->url_encode($this->{'referer_url'}) : ''));
				} elsif (!$attributes_hash{'src'} || $attributes_hash{'src'} =~ m!/spacer.gif$! || ($attributes_hash{'style'} && $attributes_hash{'style'} =~ /display:\s*none/is) || ($attributes_hash{'width'} && $attributes_hash{'width'} == 1 && $attributes_hash{'height'} && $attributes_hash{'height'} == 1)) {
					next;
				} elsif (!$attributes_hash{'width'} || $attributes_hash{'width'} > 228 || !$attributes_hash{'height'} || $attributes_hash{'height'} > 400) {
					$buf = $attributes_hash{'alt'} || $attributes_hash{'title'} || '';
					if (!$in_anchor) {
						$buf = $this->m_anchor($attributes_hash{'src'},(($this->{'is_authorized'}) ? 0 : 1)) . $buf . '[' . (($attributes_hash{'width'} && $attributes_hash{'height'}) ? ':' . $attributes_hash{'width'} . 'x' . $attributes_hash{'height'} : '') . ']</a>';
					} elsif ($buf eq '') {
						$buf = '[]'
					}
					$is_changed = 1;
				}
				if (!$is_changed) {
					$attributes_hash{'src'} = $this->m_url($attributes_hash{'src'},(($this->{'is_authorized'}) ? 0 : 1));
					$attributes_hash{'border'} = '0' if $in_anchor;
				}
			}
		} elsif ($tag eq 'a') {
			if ($closed) {
				$in_anchor-- if $in_anchor;
			} else {
				if ($attributes_hash{'href'} && $is_secure_user) {
					$attributes_hash{'href'} = $this->delink($attributes_hash{'href'});
				}
				if ($attributes_hash{'href'} && ($attributes_hash{'href'} =~ m!^javascript:!i || $attributes_hash{'href'} =~ m!/gmap\.html\?! || ($attributes_hash{'href'} eq '#' && $attributes_hash{'onclick'}))) {
					$ignore = 1;
				} else {
					if ($attributes_hash{'href'}) {
						if ($attributes_hash{'href'} =~ /^tel:/i) {
							$foot = $tel_icon;
						} elsif ($attributes_hash{'href'} =~ /^mailto:/i) {
							$foot = $mail_icon;
						} else {
							$attributes_hash{'href'} = $this->m_url($attributes_hash{'href'});
							$foot = $caution_icon if $this->current_href_is_for_pc;
						}
					}
					if (!$skippable && $postponable) {
						foreach my $k (@access_keys) {
							if (!$access_key{$k}) {
								if ($this->{'carrier'} eq 'softbank') {
									$attributes_hash{'directkey'} = $k;
								} else {
									$attributes_hash{'accesskey'} = $k;
								}
								last;
							}
						}
					}
					if ($this->{'carrier'} eq 'softbank') {
						$attributes_hash{'nonumber'} = 'nonumber';
						$attributes_hash{'directkey'} = $attributes_hash{'accesskey'} if $attributes_hash{'accesskey'} && !$attributes_hash{'directkey'};
						if (defined $attributes_hash{'directkey'} && $attributes_hash{'directkey'} ne '') {
							delete $attributes_hash{'accesskey'};
							$access_key{$attributes_hash{'directkey'}} = 1;
							$foot = $access_key_icon{$attributes_hash{'directkey'}} || '[' . $attributes_hash{'directkey'} . ']';
						}
					} else {
						$attributes_hash{'accesskey'} = $attributes_hash{'directkey'} if !$attributes_hash{'accesskey'} && $attributes_hash{'directkey'};
						if (defined $attributes_hash{'accesskey'} && $attributes_hash{'accesskey'} ne '') {
							delete $attributes_hash{'directkey'};
							$access_key{$attributes_hash{'accesskey'}} = 1;
							$foot = $access_key_icon{$attributes_hash{'accesskey'}} || '[' . $attributes_hash{'accesskey'} . ']';
						}
					}
				}
				$in_anchor++;
			}
		} elsif ($tag eq 'form') {
			if (!$closed) {
				if (uc $attributes_hash{'method'} eq 'GET') {
					$attributes_hash{'action'} = $this->m_url($attributes_hash{'action'},0,1);
					$foot = '<input type="hidden" name="guid" value="ON">' if $this->{'carrier'} eq 'docomo';
					$foot .= '<input type="hidden" name="MCONV_SESSION_ID" value="' . $this->{'session_id'} . '">' if $this->{'use_trans_sid'} && !$this->{'cookie_enabled'};
				} else {
					$attributes_hash{'action'} = $this->m_url($attributes_hash{'action'});
				}
				delete $attributes_hash{'enctype'} if $this->{'carrier'} ne 'softbank' && $this->{'carrier'} ne 'pc';
				$in_form = 1;
			} else {
				$in_form = 0;
			}
		} elsif ($tag eq 'select' && (!defined $attributes_hash{'name'} || $attributes_hash{'name'} eq '')) {
			$ignore = 1;
		} elsif ($tag eq 'button' && $attributes_hash{'onclick'}) {
			next;
		} elsif ($tag eq 'input') {
			$is_empty = 1;
			if (!$closed) {
				$attributes_hash{'type'} = lc $attributes_hash{'type'} if $attributes_hash{'type'};
				if (($attributes_hash{'src'} && $attributes_hash{'src'} =~ m!/spacer.gif$!)
					 || ($attributes_hash{'type'} =~ /^(?:checkbox|radio)$/i && (!defined $attributes_hash{'name'} || $attributes_hash{'name'} eq ''))
					 || ($attributes_hash{'type'} =~ /^button$/i && $attributes_hash{'onclick'})
					 || ($attributes_hash{'type'} =~ /^(?:file)$/i && $this->{'carrier'} ne 'softbank' && $this->{'carrier'} ne 'pc')
					) {
					next;
				}
				if ($attributes_hash{'type'} eq 'image') {
					if (!$attributes_hash{'width'} || $attributes_hash{'width'} > 228 || !$attributes_hash{'height'} || $attributes_hash{'height'} > 400) {
						$attributes_hash{'type'} = 'submit';
						delete $attributes_hash{'width'};
						delete $attributes_hash{'height'};
						delete $attributes_hash{'src'};
						delete $attributes_hash{'border'};
					} else {
						$attributes_hash{'src'} = $this->m_url($attributes_hash{'src'},(($this->{'is_authorized'}) ? 0 : 1));
					}
				} else {
					$attributes_hash{'size'} = 20 if $attributes_hash{'size'} && $attributes_hash{'size'} > 20;
				}
				if ($attributes_hash{'onchange'}) {
					if ($attributes_hash{'onchange'} =~ /cmonos\.validate\.field\(this\)\.as(?:Word|EMailAddress|Url|Color)\(\)/) {
						if ($this->{'carrier'} eq 'docomo' || $this->{'carrier'} eq 'au') {
							$attributes_hash{'istyle'} = '3';
						} elsif ($this->{'carrier'} eq 'softbank') {
							$attributes_hash{'mode'} = 'alphabet';
						} 
					}
				}
				if (($attributes_hash{'type'} && grep($_ eq $attributes_hash{'type'},'password','email','url','color')) || ((!$attributes_hash{'type'} || $attributes_hash{'type'} eq 'text') && $attributes_hash{'name'} && $attributes_hash{'name'} =~ /(?:mail|addr|url|homepage)/i)) {
					if ($this->{'carrier'} eq 'docomo' || $this->{'carrier'} eq 'au') {
						$attributes_hash{'istyle'} = '3';
					} elsif ($this->{'carrier'} eq 'softbank') {
						$attributes_hash{'mode'} = 'alphabet';
					} 
					$attributes_hash{'type'} = 'text' if !$attributes_hash{'type'} || $attributes_hash{'type'} ne 'password';
				} elsif (($attributes_hash{'type'} && grep($_ eq $attributes_hash{'type'},'number','tel','date','datetime','datetime-local','month','week','time','range')) || ((!$attributes_hash{'type'} || $attributes_hash{'type'} eq 'text') && $attributes_hash{'name'} && $attributes_hash{'name'} =~ /(?:num|tel|fax)/i)) {
					if ($this->{'carrier'} eq 'docomo' || $this->{'carrier'} eq 'au') {
						$attributes_hash{'istyle'} = '4';
					} elsif ($this->{'carrier'} eq 'softbank') {
						$attributes_hash{'mode'} = 'numeric';
					} 
					$attributes_hash{'type'} = 'text';
				} elsif (!$attributes_hash{'type'} || $attributes_hash{'type'} eq 'search') {
					$attributes_hash{'type'} = 'text';
				}
			}
		} elsif ($tag eq 'textarea') {
			if (!$closed) {
				$attributes_hash{'rows'} = 8 if $attributes_hash{'rows'} && $attributes_hash{'rows'} > 8;
				$attributes_hash{'cols'} = 20 if $attributes_hash{'cols'} && $attributes_hash{'cols'} > 20;
			}
			if ($attributes_hash{'onchange'}) {
				if ($attributes_hash{'onchange'} =~ /cmonos\.validate\.field\(this\)\.as(?:Word|EMailAddress|Url|Color)\(\)/) {
					if ($this->{'carrier'} eq 'docomo' || $this->{'carrier'} eq 'au') {
						$attributes_hash{'istyle'} = '3';
					} elsif ($this->{'carrier'} eq 'softbank') {
						$attributes_hash{'mode'} = 'alphabet';
					} 
				}
			}
		} elsif ($tag eq 'table') {
			$tag = 'div';
			if (!$closed) {
				$head = $separator if !$continual_separator;
				$table_start = 1;
				$continual_separator = 1;
				$parsable++ if $parsable || $this->is_target_element(\@parsable_tables,$original_tag,$attributes_hash{'id'},$attributes_hash{'class'});
				push(@th,[]) if $parsable;
			} else {
				$table_start = 0;
				$simpleparsable-- if $simpleparsable;
				$parsable-- if $parsable;
				pop @th if @th;
				$is_th = 0;
				$col = 0;
			}
			$in_thead = 0;
		} elsif ($tag eq 'tr') {
			$table_start = $col = 0;
			if ($closed && !$continual_separator) {
				$buf = $separator;
				$continual_separator = 1;
				$is_changed = 1;
			} else {
				next;
			}
		} elsif ($tag eq 'td') {
			my $colspan = ($attributes_hash{'colspan'} && $attributes_hash{'colspan'} =~ /^\d+$/) ? $attributes_hash{'colspan'} : 1;
			$table_start = 0;
			$tag = 'div';
			if ($closed && $sc_name_cell) {
				$sc_name_cell = 0;
				$head = '] ';
			} elsif (!$closed && $attributes_hash{'class'} && $attributes_hash{'class'} =~ /sc-name/) {
				$col += $colspan;
				$foot = '[';
				$sc_name_cell = 1;
			} elsif ($attributes_hash{'class'} && $attributes_hash{'class'} =~ /sc-value/) {
				$col += $colspan if !$closed;
			} elsif ($parsable) {
				if (!$closed) {
					if (ref $th[$#th] && $th[$#th][$col]) {
						$th[$#th][$col] =~ s/<\/?(?:div|p)(?!\w)[^>]*>//igs;
						$foot = '<div>[' . $th[$#th][$col] . ']</div>';
						$continual_separator = 0;
					}
					$col += $colspan;
				} elsif (!$continual_separator) {
					$head = $separator;
					$continual_separator = 1;
				}
			} elsif ($simpleparsable && !$closed) {
				if (ref $th[$#th] && $th[$#th][$col]) {
					$th[$#th][$col] =~ s/<\/?(?:div|p)(?!\w)[^>]*>//igs;
					$foot = '[' . $th[$#th][$col] . '] ';
					$continual_separator = 0;
				}
				$col += $colspan;
			}
		} elsif ($tag eq 'th') {
			my $colspan = ($attributes_hash{'colspan'} && $attributes_hash{'colspan'} =~ /^\d+$/) ? $attributes_hash{'colspan'} : 1;
			$table_start =0;
			$tag = 'div';
			if (!$in_thead && $simpleparsable) {
				if (!$closed) {
					$foot = '<b>[';
					if (ref $th[$#th] && $th[$#th][$col]) {
						$th[$#th][$col] =~ s/<\/?(?:div|p)(?!\w)[^>]*>//igs;
						$foot .= $th[$#th][$col] . ':';
						$continual_separator = 0;
					}
					$col += $colspan;
				} else {
					$head = ']</b>';
				}
			} elsif ($parsable || ($in_thead && $simpleparsable)) {
				if (!$closed) {
					$ignore = 1;
					$buf = '';
					$is_th = 1;
					$col += $colspan;
				} else {
					$is_th = 0;
				}
			} else {
				if (!$closed) {
					$foot = '[';
				} else {
					$head = ']';
				}
			}
		} elsif ($tag eq 'hr') {
			if (!$closed) {
				$continual_separator = 1;
				$attributes_hash{'width'} = '100%' if $attributes_hash{'width'} && $attributes_hash{'width'} =~ /^\d+$/ && $attributes_hash{'width'} > 228;
			}
		}
		next if !$closed && $is_empty && $attributes_hash{'style'} && $attributes_hash{'style'} =~ /display:\s*none/is;
		if (!$is_changed) {
			if (!$closed && !$ignore) {
				foreach my $k ('type','href','name') {
					$attributes .= ' ' . $k . '="' . $attributes_hash{$k} . '"' if defined $attributes_hash{$k} && $attributes_hash{$k} ne '';
				}
				while (my($k,$v) = each %attributes_hash) {
					if (!grep($_ eq $k,'type','href','name','id','rel','class','style','target','title','colspan','rowspan','valign','cellspacing','cellpadding','summary') && $k !~ /^on/) {
						$attributes .= ' ' . $k . ((grep($_ eq $k,'utn','multiple','selected','checked','nonumber')) ? '' : '="' . $v . '"');
					}
				}
			}
			$buf = '<' . $closed . $tag . $attributes . '>' if $buf;
			if (!$is_empty && !$closed) {
				$skippable++ if $skippable || $ignore || ($attributes_hash{'style'} && $attributes_hash{'style'} =~ /display:\s*none/is) || $this->is_target_element(\@skippable_elements,$original_tag,$attributes_hash{'id'},$attributes_hash{'class'});
				$postponable++ if $postponable || $this->is_target_element(\@postponable_elements,$original_tag,$attributes_hash{'id'},$attributes_hash{'class'});
				push(@open_tags,$buf) if !$skippable && !$postponable;
			}
		}
		$buf = $head . $buf . $foot if $buf;
	} elsif ($buf =~ /^<!--m:pagebreak(?!\w)(.*?)-->$/is) {
		next if $break_disabled;
		$continual_separator = $pagesize = 0;
		$buf = '';
		my $config = $1;
		my $prev = ($config =~ /\sprev="([^"]*)"/is) ? $this->unescape($1) : $prev_text;
		my $next = ($config =~ /\snext="([^"]*)"/is) ? $this->unescape($1) : $next_text;
		last if $this->page_break($p,\$page_count,\@open_tags,$prev,$next);
	} elsif ($buf !~ /\S/s) {
		next;
	} elsif (!$skippable) {
		$continual_separator = 0;
	}
	if ($buf ne '') {
		if ($is_th) {
			$th[$#th][$col-1] .= $cgi::Jcode->set($buf)->sjis;
		} elsif (!$skippable) {
			$buf = $cgi::Jcode->set($buf)->sjis;
			if ($postponable) {
				$postponable_html .= $buf;
			} else {
				$pagesize += length $buf;
				print $buf if $p == $page_count;
			}
		}
	}
	if ($tag && !$is_changed && !$is_empty && $closed) {
		if (!$skippable && !$postponable) {
			my @temp = ();
			my $done = 0;
			foreach my $t (reverse @open_tags) {
				if (!$done && $t =~ /^<$tag(?!\w)[^>]*>$/s) {
					$done = 1;
				} else {
					unshift(@temp,$t);
				}
			}
			@open_tags = @temp;
		}
		$skippable-- if $skippable;
		$postponable-- if $postponable;
	}
}
print $postponable_html;
if ($this->{'carrier'} eq 'pc') {
	print $cgi::Jcode->set($separator . '<center><b><a href="' . $this->{'target_url'} . $this->{'query_string'} . '">PC ڡ˰ư</a></center>')->sjis;
} elsif ($caution_icon && $this->{'has_outlinks'}) {
	print $separator . '<div><font size="2">';
	print $caution_icon;
	print $cgi::Jcode->set('ΤĤ󥯤ϳ󥯤Ǥ褬PCѥȤǤǽޤ')->sjis;
	print '</font></div>';
}
print '</body></html>';
}

sub page_break ($$$$$$) {
my($this,$p,$page_count_ref,$open_tags_array,$prev,$next) = @_;
if ($p == $$page_count_ref) {
	foreach my $t (reverse @$open_tags_array) {
		if ($t =~ /^<(\w+)/) {
			print '</' . $1 . '>';
		}
	}
	print '<center><a href="' . $this->escape($this->append_guid($this->{'self_path'} . '.P' . ($p+1) . $this->{'query_string'})) . '">' . $cgi::Jcode->set($next)->sjis . '</a></center>';
	return 1;
}
$$page_count_ref++;
if ($p > 1 && $p == $$page_count_ref) {
	print '<center><a href="' . $this->escape($this->append_guid($this->{'self_path'} . '.P' . ($p-1) . $this->{'query_string'})) . '">' . $cgi::Jcode->set($prev)->sjis . '</a></center>';
	print join('',@$open_tags_array);	#ϥ
}
return 0;
}

sub session_decode ($$) {
my($this,$sid) = @_;
return '' if !$sid;
$sid =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
return $sid;
}

sub is_target_element ($$$$$) {
my($this,$targets,$tag,$id,$class) = @_;
my @class_name = ($class) ? split(/\s+/,$class) : ();
foreach my $t (@$targets) {
	if (($id && $t eq $id) || grep($t eq '.' . $_ || ($tag && $t eq $tag . '.' . $_),@class_name)) {
		return 1;
	}
}
return 0;
}

sub object_link ($$;$) {
my($this,$attributes,$content) = @_;
my $src = ($attributes =~ /\ssrc=['"]?([^"\s]+)/i || ($content && $content =~ /<source(?!\w)[^>]*\ssrc=['"]?([^"\s]+)['"]?[^>]*>/is)) ? $this->unescape($1) : '';
if ($src && $src =~ /([^\/]+\.(mp3|amc|3g2|3gp|mp4|m4v|m4a))$/i) {
	my $filename = $1;
	my $ext = $2;
	return $this->m_anchor($src,1) . (($attributes =~ /\s(?:title|alt)=['"]?([^"\s]+)/i) ? $1 . (($ext) ? '(' . $ext . ')' : '') : $filename) . '</a>';
}
return '';
}

sub m_anchor ($$;$) {
my($this,$url,$is_not_html) = @_;
return '<a href="' . $this->m_url($url,$is_not_html) . '">';
}

sub m_url ($$;$$) {
my($this,$url,$is_not_html,$noguid) = @_;
delete $this->{'href_for_pc'};
return '' if !$url;
return $url if $url =~ /^[#\?]/ || ($url !~ /^https?:\/\//i && $url =~ /^\w+:/);
$url = $this->unescape($url);
if ($this->{'is_out_of_domain'} && $url !~ m!^https?://!i) {
	$url = $this->{'current_domain'} . $this->path_change($url,$this->{'current_path'},'abs');
}
return $url if $url =~ m!/m\.cgi/!;
if (!$is_not_html) {
	my $path = ($url =~ /^https?:\/\/[^\/]+(.*?)$/i) ? $1 : $url;
	if ($this->{'is_authorized'} || $path =~ /\.(?:s?html?|phtml?|pl|cgi|pm|vbs|asp|exe|app|php|rb)(?=(?:\/|\?|\#|$))/ || $path !~ /\.\w+(?=(?:\/|\?|\#|$))/) {
		my $is_inside;
		if ($url =~ s!^$this->{'here'}/!!) {
			$is_inside = 1;
		} elsif ($url =~ /^https?:\/\/([^\/]+)/i) {
			$is_inside = 1 if !$this->is_not_target_domain($1);
		} else {
			$url = $this->un_base_change($url,$this->{'current_path'},'rel');
			my $domain = $this->{'current_domain'};
			$domain =~ s!^https?://!!is;
			$is_inside = 1 if $url !~ /^\.\.\// || !$this->is_not_target_domain($domain);
		}
		if ((!$is_inside && $this->{'carrier'} eq 'pc') || $this->is_not_target_url($url)) {
			$url = $this->path_change($url,$ENV{'SCRIPT_NAME'},'abs') if $url !~ m!^https?://!i && $url !~ m!^/!;
			return $this->escape($url);
		} else {
			$this->{'href_for_pc'} = $this->{'has_outlinks'} = 1 if !$is_inside;
			$url = $this->full_path($url) if $url =~ /^\.\.\//;
			$url =~ s!^\./!!;
			$url .= '/' if $url =~ m!(?:^|/)[^\./]+$!;
			return $this->escape($this->append_guid($ENV{'SCRIPT_NAME'} . '/' . $url,$noguid));
		}
	}
}
if ($url !~ m!^https?://!i && $url !~ m!^/!) {
	$url = $this->path_change($url,$this->{'current_path'},'abs');
}
return $this->escape($url);
}

sub current_href_is_for_pc ($) {
my $this = shift;
my $for_pc = ($this->{'href_for_pc'}) ? 1 : 0;
delete $this->{'href_for_pc'};
return $for_pc;
}

sub is_not_target_url ($$) {
my($this,$url) = @_;
if (ref $this->{'ignorable_url'} && @{$this->{'ignorable_url'}}) {
	$url = $this->full_path($url) unless $url =~ s/^(https?:\/\/[^\/]+)(.*?)$/lc($1) . $2/ei;
	foreach my $ig (@{$this->{'ignorable_url'}}) {
		return 1 if $url =~ /^\Q$ig\E/;
	}
}
return 0;
}

sub append_guid ($$;$) {
my($this,$url,$noguid) = @_;
if (!$noguid) {
	$url .= (($url =~ /\?/) ? '&' : '?') . 'MCONV_SESSION_ID=' . $this->{'session_id'} if $this->{'use_trans_sid'} && !$this->{'cookie_enabled'};
	$url .= (($url =~ /\?/) ? '&' : '?') . 'guid=ON' if $this->{'carrier'} eq 'docomo';
}
return $url;
}

sub sim_ssi ($$) {
my($this,$attributes) = @_;
if ($attributes =~ / class="sim-ssi"/ && $attributes =~ / src="([^"]+)"/) {
	my $src = $1;
	if ($src =~ s/\.js$/.ssi/) {
		$src = $this->{'current_domain'} . (($src =~ /^\//) ? $src : $this->path_change($src,$this->{'current_path'},'abs')) if $src !~ /^https?:\/\//i;
		if ($src =~ s!^$this->{'here'}/!\./!) {
			return $this->read_file($src,1);
		} else {
			my $res = HTTP_Client->new->request('GET' => $src);
			return $res->content('euc') if $res->is_success;
		}
	}
}
return '';
}

sub get_guid ($$;$) {
my($this,$user_id,$salt) = @_;
return '' if !defined $user_id || $user_id eq '';
$user_id = $this->encrypt($user_id,($salt || 'mB'),1);
$user_id =~ s/\./\-/g;
$user_id =~ s/\//\_/g;
return 'm.' . $user_id;
}

sub get_cookie_by_uid ($;$) {
my($this,$user_id) = @_;
return '' if $this->{'is_bot'};
local(*COOKIE,*TEMP);
my $file = $this->{'store'} . '/' . $this->{'session_id'};
if ($this->{'use_trans_sid'} && !$this->{'cookie_enabled'} && !$user_id && -f $file && -M $file > 1) {
	unlink $file;
	$this->{'session_id'} = 'm.' . $this->unique_id;
	return '';
}
my $temp = $file . '.temp';
my $cookies = '';
my $now = time;
my $delete = 0;
if (open(COOKIE, $file)) {
	binmode COOKIE;
	flock(COOKIE, LOCK_SH);
	if (open(TEMP, ">>$temp")) {
		binmode TEMP;
		flock(TEMP, LOCK_EX);
		truncate(TEMP, 0);
		seek(TEMP, 0, 0);
		my($ref1,$ref2);
		while (my $cookie = <COOKIE>) {
			if ($cookie =~ /^REFERER=(.*?)\x0A$/) {
				$ref1 = $1;
				print TEMP $cookie;
			} elsif ($cookie =~ /^REFERERx2=(.*?)\x0A$/) {
				$ref2 = $1;
				print TEMP $cookie;
			} elsif ($cookie =~ /^UA=(.*?)\x0A$/) {
				$delete = 1 if $this->{'use_trans_sid'} && $ENV{'HTTP_USER_AGENT'} ne $1;
				print TEMP $cookie;
			} elsif ($cookie =~ /^GUID=(.*?)\x0A$/) {
				$delete = 1 if $this->{'use_trans_sid'} && $user_id ne $1;
				print TEMP $cookie;
			} else {
				chomp $cookie;
				my($d,$p,$etime,$name,$value,$secure) = split(/\x09/,$cookie);
				if ($etime && $now < $etime) {
					print TEMP $cookie,"\x0A";
					if ((!$secure || $this->{'current_domain'} =~ m!^https://!i) && $this->{'current_domain'} =~ /\Q$d\E$/i && $this->{'current_path'} =~ /^$p/) {
						$value =~ s/[\x0A\x0D]+//g;
						$cookies .= $name . '=' . $value . ';';
					}
				}
			}
			last if $delete;
		}
		close(TEMP);
		if ($ref2 && $ENV{'REQUEST_METHOD'} ne "POST" && (!$ref1 || $this->{'target_url'} . $this->{'query_string'} eq $ref1)) {
			$this->{'referer_url'} = $ref2;
		} elsif ($ref1) {
			$this->{'referer_url'} = $ref1;
		}
	}
	close(COOKIE);
	rename($temp,$file);
	if ($delete) {
		unlink $file;
		$this->{'session_id'} = 'm.' . $this->unique_id if $this->{'use_trans_sid'};
		return '';
	}
}
return $cookies;
}

sub save_cookie_by_uid ($$;$$) {
my($this,$cookies,$user_id,$keep_referer) = @_;
return 0 if $this->{'is_bot'};
local(*COOKIE,*TEMP);
my %new_cookies = ();
if (ref $cookies && @$cookies) {
	my $mydomain = ($this->{'current_domain'} =~ m!^https?://(.*)$!) ? $1 : lc $this->to_host($ENV{'SERVER_NAME'});
	foreach my $data (@$cookies) {
		my($d,$p,$etime,$name,$value,$secure);
		if ($data =~ s/\s*secure$//i) {
			$secure = 'secure';
		} else {
			$secure = '';
		}
		if ($data =~ s/\s*expires=(.*?)(?:;|$)//i) {
			my $expires = $1;
			if ($expires =~ /\s(\d+)-(\w+)-(\d+)\s+(\d+):(\d+):(\d+)/) {
				my %month = ('jan'=>0,'Feb'=>1,'Mar'=>2,'Apr'=>3,'May'=>4,'Jun'=>5,'Jul'=>6,'Aug'=>7,'Sep'=>8,'Oct'=>9,'Nov'=>10,'Dec'=>11);
				my($d,$m,$y,$h,$min,$sec) = ($1+0,($month{$2} || 11),$3+0,$4+0,$5+0);
				$etime = timegm($sec,$min,$h,$d,$m,$y);
			} else {
				$etime = time + 86400;
			}
		} else {
			$etime = time + 86400;
		}
		if ($data =~ s/\s*path=(.*?)(?:;|$)//i) {
			$p = $1;
		} else {
			$p = $this->{'current_path'} || '/';
		}
		if ($data =~ s/\s*domain=(.*?)(?:;|$)//i) {
			$d = lc $1;
		} else {
			$d = $mydomain;
		}
		if ($data =~ s/\s*(\w+)=(.*?)(?:;|$)//i) {
			($name,$value) = ($1,$2);
		} else {
			next;
		}
		$new_cookies{$d . $p . ':' . $name} = ($etime < time) ? '' : join("\x09",$d,$p,$etime,$name,$value,$secure);
	}
}
my $file = $this->{'store'} . '/' . $this->{'session_id'};
$this->cookie_gc if !-f $file || -M $file > $this->{'lifetime'};
my $temp = $file . '.temp';
my $now = time;
if (open(TEMP, ">>$temp")) {
	binmode TEMP;
	flock(TEMP, LOCK_EX);
	truncate(TEMP, 0);
	seek(TEMP, 0, 0);
	my $keep_ref2 = ($keep_referer || $ENV{'REQUEST_METHOD'} eq "POST") ? 1 : 0;
	print TEMP 'REFERER=' . $this->{'target_url'} . $this->{'query_string'} . "\x0A" if !$keep_referer;
	print TEMP 'REFERERx2=' . $this->{'referer_url'} . "\x0A" if !$keep_ref2 && $this->{'referer_url'};
	print TEMP 'UA=' . $ENV{'HTTP_USER_AGENT'} . "\x0A" if $this->{'use_trans_sid'} && $ENV{'HTTP_USER_AGENT'} !~ /[\x0A\x0D]/;
	print TEMP 'GUID=' . $user_id . "\x0A" if $this->{'use_trans_sid'} && defined $user_id && $user_id ne '';
	if (open(COOKIE, $file)) {
		binmode COOKIE;
		flock(COOKIE, LOCK_SH);
		while (my $cookie = <COOKIE>) {
			if ($cookie =~ /\x09/) {
				my($d,$p,$etime,$name) = split(/\x09/,$cookie);
				my $key = $d . $p . ':' . $name;
				if (defined $new_cookies{$key}) {
					print TEMP $new_cookies{$key} . "\x0A" if $new_cookies{$key} ne '';
					delete $new_cookies{$key};
				} elsif ($etime && $now < $etime) {
					print TEMP $cookie;
				}
			} elsif ($keep_referer && $cookie =~ /^REFERER=/) {
				print TEMP $cookie;
			} elsif ($keep_ref2 && $cookie =~ /^REFERERx2=/) {
				print TEMP $cookie;
			}
		}
		close(COOKIE);
	}
	while (my($k,$v) = each %new_cookies) {
		print TEMP $v . "\x0A" if $v;
	}
	close(TEMP);
	rename($temp,$file);
}
return 1;
}

sub is_not_target_domain($$) {
my($this,$domain) = @_;
$domain = lc $domain;
return (grep($_ eq $domain || $_ eq 'all',@{$this->{'target_domain'}})) ? 0 : 1;
}

sub cookie_gc ($) {
my $this = shift;
local(*STORE);
opendir(STORE, $this->{'store'});
while (my $id = readdir(STORE)) {
	my $session = $this->{'store'} . '/' . $id;
	unlink $session	if $id =~ /^m\./ && -f $session && -M $session > $this->{'lifetime'};
}
closedir(STORE);
return $this;
}


1;

