package RgCommon;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ѥϿ̥⥸塼
# RgCommon.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-04-04
######################################################################
# ID
sub id_info ($$) {
my($this,$email) = @_;
my $pswd;
$this->use_register if !ref $cgi::Register;
$pswd = $cgi::Register->read_crypt($email) if defined $email && $email ne '';
return (
	$this->is_secure('pswd',1),
	((defined $pswd && $pswd ne '') ? 1 : 0),
	((defined $pswd && $pswd ne '' && $cgi::Register->is_identifier($email,$pswd)) ? $pswd : ''),
	(($setting::general{'reregistry'} && defined $pswd && $pswd ne '') ? 1 : 0),
);
}

sub endpoint_normalize ($$) {
my($this,$url) = @_;
if (!$url) {
	return '';
} elsif ($url !~ m!://!) {
	return 'https://' . $url;
}
$url =~ s!^\w+://!https://!gi;
$url =~ s/#.*$//;
return $url;
}

sub openid_provider_array ($) {
my $this = shift;
return [] if !$env::openid_enabled || !$setting::general{'op'};
my $op = [];
while ($setting::general{'op'} =~ /^([^=]*)=([^\x0A\x0D]+)\s*$/mg) {
	my $name = $1;
	my @info = split(/;/,$2,3);
	push(
		@$op,
		{
			'name'			=>	(($name) ? $name : 'OpenID Provider'),
			'endpoint_url'	=>	$this->endpoint_normalize($info[0]),
			'claimed_id'	=>	(($info[1]) ? $info[1] : ''),
			'identity'		=>	(($info[2]) ? $info[2] : ''),
		}
	) if $2;
}
return $op;
}

sub is_secure_op ($$) {
my($this,$endpoint_url) = @_;
return 0 if !$endpoint_url;
return 1 if $setting::general{'anyOp'};
foreach my $op (@{$this->openid_provider_array}) {
	return 1 if $op->{'endpoint_url'} eq $endpoint_url;
}
return 0;
}

sub op_info_from_id ($$) {
my($this,$id) = @_;
my $info = $this->openid_provider_array->[$id];
return (defined $info && ref $info) ? $info : {};
}

sub print_openid_login_panel_opener ($$$$) {
my($this,$email,$claimed_id,$url) = @_;
my $op = $this->openid_provider_array;
if (!$claimed_id && @$op && $setting::general{'anyOp'}) {
	$this->set_javascript('cmonos.tool.toggleOpenIdForm = function (this_op) {if (this_op == "") { document.getElementById("openid-identifier").style.display = "table-row"; document.getElementById("identifier").focus(); } else { document.getElementById("openid-identifier").style.display = "none"; }}');
}
$this->print_page_header($setting::key);

print $this->form_start(
	'key'	=>	'password',
	'name'	=>	'input',
	'method'	=> 'post',
	(($setting::key ne 'rp') ? ('target'	=> '_blank') : ()),
);
print '<input type="hidden" name="m" value="RP" />';
print '<input type="hidden" name="k" value="rp" />';
print '<input type="hidden" name="transition" value="1" />' if $main::transition;

print '<table class="field-table"><tbody>';
if ($email) {
	print '<tr>';
	print '<td class="field-name"><span class="datatitle">᡼륢ɥ쥹</span></td>';
	print '<td class="field">' . $this->escape($email) . '<input type="hidden" name="addr" value="' . $this->escape($email) . '" /></td>';
	print '</tr>';
} else {
	print '<tr>';
	print '<td class="field-name"><label for="addr">᡼륢ɥ쥹</label></td>';
	print '<td class="field"><input type="text" name="addr" id="addr" size="32" value="' . $this->escape($email) . '" /></td>';
	print '</tr>';
}
if (!$claimed_id) {
	if (@$op) {
		print '<tr>';
		print '<td class="field-name"><span class="datatitle">OpenID ץХ</span></td>';
		print '<td class="field">';
		if ((@$op > 1) || (@$op && $setting::general{'anyOp'})) {
			print '<select name="op"' . (($setting::general{'anyOp'}) ? ' onchange="cmonos.tool.toggleOpenIdForm(this.options[this.selectedIndex].value)"' : '') . '>';
			for (my $i = 0; $i < @$op; $i++) {
				print '<option value="' . $i . '"' . ((defined $main::op && $main::op eq $i) ? ' selected="selected"' : '') . '>' . $this->escape($op->[$i]->{'name'}) . '</option>';
			}
			print '<option value=""' . ((!defined $main::op || $main::op eq '') ? ' selected="selected"' : '') . '>¾ OpenID</option>' if $setting::general{'anyOp'};
			print '</select>';
		} elsif (@$op == 1) {
			print $this->escape($op->[0]->{'name'});
			print '<input type="hidden" name="op" value="0" />';
		}
		print '</td>';
		print '</tr>';
	}
	if ($setting::general{'anyOp'}) {
		print '<tr id="openid-identifier">';
		print '<td class="field-name"><label for="identifier">OpenID</label></td>';
		print '<td class="field"><input type="text" name="identifier" id="identifier" size="20" value="' . $this->escape($main::identifier) . '" class="open-id" /></td>';
		print '</tr>';
	}
}
print '<tr>';
print '<td class="close-box">';
if ($url) {
	$this->use_deco if !ref $cgi::Deco;
	print $cgi::Deco->button('return',$setting::page{'backButton'},$url,(($default::english) ? 'Return.' : ''));
} else {
	print $this->close_button('',$setting::page{'closeButton'},$setting::page{'backButton'});
}
print '</td>';
print '<td class="submit-box"><input type="submit" value="" /></td></tr>';
print '</tbody></table></form>';

#ġ륢
$this->print_tool_icon if $this->is_secure('tools');

#ڡեå
$this->print_page_footer($setting::key);

exit;
}

1;
