// CMONOS.JP JavaScript Library cart.js
// Copyright 2009-2011 cmonos.jp
// Last-Mocified:2011-04-30

cmonos.tool.shoppingcart = {

	window : {
		step_by_step : true,
		type : "iframe",
		margin_top : 0,
		margin_left : -250,
		target_width : 226,
		target_height : 480,
		width : 1,
		height : 1,
		enlarging_timer : null,
		fixed_timer : null,
		narrowdown : false,
		narrowdown_timer : null,
		pos_top : 0,
		pos_left : 0,
		iframe : null,

		open : function (this_form) {
			if (this.type == null || this.type == 'self') {
				return true;
			} else if (this.type == 'new') {
				window.open('','shoppingcart','width=' + ((this.target_width != null) ? this.target_width : 640) + ',height=' + ((this.target_height != null) ? this.target_height : 480) + ',scrollbars=yes,resizable=yes');
				this_form.target = "shoppingcart";
				return true;
			}
			if (document.getElementById('shoppingcart')) {
				if (this.narrowdown) {
					document.getElementsByTagName('body')[0].removeChild(document.getElementById('shoppingcart'));
				} else {
					this_form.target = "shoppingcart";
					return true;
				}
			}
			this.narrowdown = false;
			var this_body;
			var ms = false;
			this.width = 1;
			this.height = 1;
			var scroll_top = cmonos.window.getPageYOffset();
			var scroll_left = cmonos.window.getPageXOffset();
			if (document.body.insertAdjacentHTML) {
				document.body.insertAdjacentHTML('AfterBegin','<iframe id="shoppingcart" name="shoppingcart" style="position: absolute; z-index: 999;"></iframe>');
				this.iframe = document.getElementById('shoppingcart');
				ms = true;
			} else {
				this_body = document.getElementsByTagName('body')[0];
				this.iframe = document.createElement('iframe');
				this.iframe.id = 'shoppingcart';
				this.iframe.name = 'shoppingcart';
				this.iframe.style.position = "absolute";
				this.iframe.style.zIndex = 999;
			}
			if (this.margin_top < 0) {
				this.pos_top = scroll_top + cmonos.window.getInnerHeight() + this.margin_top;
			} else {
				this.pos_top = this.margin_top + scroll_top;
			}
			this.iframe.style.top = this.pos_top + "px";
			if (this.margin_left < 0) {
				this.pos_left = scroll_left + cmonos.window.getInnerWidth() + this.margin_left;
			} else {
				this.pos_left = this.margin_left + scroll_left;
			}
			this.iframe.style.left = this.pos_left + "px";
			this.iframe.style.width = "1px";
			this.iframe.style.height = "1px";
			if (!ms) this_body.appendChild(this.iframe);
			this_form.target = "shoppingcart";
			var this_window = this;
			this.enlarging_timer = setInterval(function () { this_window.enlarge(); },10);
			return true;
		},

		enlarge : function () {
			if (!this.iframe) {
				clearInterval(this.enlarging_timer);
				return;
			}
			if (this.width < this.target_width) {
				this.iframe.style.width = this.width+"px";
				this.width += Math.ceil((this.target_width - this.width) / 4);
			}
			if (!this.step_by_step || this.width >= this.target_width) {
				if (this.height < this.target_height) {
				this.iframe.style.height = this.height+"px";
				this.height += Math.ceil((this.target_height - this.height) / 4);
				}
				if (this.width >= this.target_width && this.height >= this.target_height) {
					clearInterval(this.enlarging_timer);
					var this_window = this;
					this.fixed_timer = setInterval(function () { this_window.fix() },100);
				}
			}
		},

		fix : function () {
			if (this.iframe) {
				var scroll_top = cmonos.window.getPageYOffset();
				var scroll_left = cmonos.window.getPageXOffset();
				var margin_top = (this.margin_top < 0) ? cmonos.window.getInnerHeight() + this.margin_top : this.margin_top;
				var margin_left = (this.margin_left < 0) ? cmonos.window.getInnerWidth() + this.margin_left : this.margin_left;
				this.iframe.style.top = this.pos_top+"px";
				this.iframe.style.left = this.pos_left+"px";
				this.pos_top += Math.ceil((scroll_top + margin_top - this.pos_top) / 8);
				this.pos_left += Math.ceil((scroll_left + margin_left - this.pos_left) / 8);
			} else {
				clearInterval(this.fixed_timer);
				return true;
			}
		},

		close : function () {
			if (parent && parent.document.getElementById('shoppingcart')) {
				parent.cmonos.tool.shoppingcart.window.narrowdown = true;
				parent.cmonos.tool.shoppingcart.window.width = parseInt(parent.document.getElementById('shoppingcart').style.width);
				parent.cmonos.tool.shoppingcart.window.height = parseInt(parent.document.getElementById('shoppingcart').style.height);
				parent.cmonos.tool.shoppingcart.window.narrowdown_timer = setInterval(function () { parent.cmonos.tool.shoppingcart.window.narrowDown() },10);
			}
		},

		narrowDown : function () {
			if (this.narrowdown_timer == null) return;
			this.iframe.style.height = this.height+"px";
			this.height -= Math.ceil((this.height) / 4);
			if (!this.step_by_step || this.height <= 1) {
				this.iframe.style.width = this.width+"px";
				this.width -= Math.ceil((this.width) / 4);
				if (this.width <= 1 && this.height <= 1) {
					if (this.iframe) document.getElementsByTagName('body')[0].removeChild(this.iframe);
					clearInterval(this.narrowdown_timer);
					this.narrowdown_timer = null;
					this.narrowdown = false;
				}
			}
		},

		sizeCheck : function (min_width,min_height) {
			if (parent && parent != self) return;
			var resize_x = 0;
			var resize_y = 0;
			var inner_width = cmonos.window.getInnerWidth();
			var inner_height = cmonos.window.getInnerHeight();
			if (min_width != null && min_width > inner_width) {
				resize_x = min_width - inner_width;
			}
			if (min_height != null && min_height > inner_height) {
				resize_y = min_height - inner_height;
			}
			if (resize_x > 0 || resize_y > 0) window.resizeBy(resize_x,resize_y);
		}
	},

	alert_required : true,
	recalculate : function () {
		var partial_sum = 0;
		var total_sum = 0;
		for(var i=0; i<this.data.item.length; i++) {
			if (isNaN(document.getElementById(this.data.item[i].quantity_id).value)) {
				document.getElementById(this.data.item[i].quantity_id).value = "0";
			}
			var price = this.data.item[i].price * document.getElementById(this.data.item[i].quantity_id).value;
			partial_sum += price;
			document.getElementById(this.data.item[i].price_id).innerHTML = "&yen;"+cmonos.value.comma(price);
		}
		if (this.data.tax_rate != null && this.data.tax_rate > 0) {
			document.getElementById(this.data.sc_sub_total_id).innerHTML = "&yen;"+cmonos.value.comma(partial_sum);
			var tax = partial_sum * this.data.tax_rate;
			tax = (this.data.tax_frac == null || this.data.tax_frac == "ceil") ? Math.ceil(tax) : (this.data.tax_frac == "floor") ? Math.floor(tax) : Math.round(tax);
			partial_sum += tax;
			document.getElementById(this.data.sc_tax_id).innerHTML = "&yen;"+cmonos.value.comma(tax);
		}
		document.getElementById(this.data.sc_total_id).innerHTML = "&yen;"+cmonos.value.comma(partial_sum);
		if (this.alert_required) {
			alert('ֺƷ׻פ뤫֥쥸˿ʤפޤǡ̤ѹ¸ޤ');
			this.alert_required = false;
		}
	},

	deleteItem : function (this_trash,item_id) {
		this_trash.className += '-active';
		document.getElementById('quantity:'+item_id).value = "0";
		document.getElementById('sc-item-'+item_id).style.display = "none";
		var n = 0;
		for(var i=0; i<this.data.item.length; i++) {
			var this_tr = document.getElementById(this.data.item[i].price_id.replace(/-price/,""));
			if (this_tr.style.display != "none") this_tr.className = (n++ % 2) ? "even" : "odd";
		}
		if (!this.ajaxDisabled) {
			this.alert_required = false;
			this.recalculate();
			cmonos.xml.request(
				document.location.href.replace(/\?.*$/,""), 
				{
					method: 'post', 
					parameters: 'm=HandyCart&cancel='+escape(item_id), 
					onComplete: function(){this_trash.className = this_trash.className.replace(/-active$/,"");}
				}
			);
		} else {
			this.recalculate();
			this_trash.className = this_trash.className.replace(/-active$/,"");
		}
	},

	changeItem : function (item_id,item_quantity) {
		if (!this.ajaxDisabled) {
			this.alert_required = false;
			this.recalculate();
			cmonos.xml.request(
				document.location.href.replace(/\?.*$/,""), 
				{
					method: 'post', 
					parameters: 'm=HandyCart&item='+escape(item_id)+'&quantity='+escape(item_quantity)
				}
			);
		} else {
			this.recalculate();
		}
	},

	setTarget : function (this_form) {
		if (!window.opener && parent.document.getElementById('shoppingcart')) {
			this_form.target = '_parent';
		}
		return true;
	}
}