// CMONOS.JP JavaScript Library dt.js
// Copyright 2007-2011 cmonos.jp
// Last Modified:2011-02-04

cmonos.validate.calendarDatetime = {
	se_gap : 3600000,
	eu_gap : 0,
	
	fix : function (dt_type) {
		var date = (document.getElementById('dt:date') && document.getElementById('dt:date').checked) ? true : false;
		if (date) {
			cmonos.element.item('dt-start-time','dt-end-time').disappear(true);
			if (this.se_gap < 86400000) this.se_gap = 86400000;
		} else {
			cmonos.element.item('dt-start-time','dt-end-time').disappear(false);
		}
		var dt_start = cmonos.validate.datetime.getDateFromMenu('dt:sy','dt:sm','dt:sd','dt:sh','dt:smin',date);
		var dt_start_time = dt_start.getTime();
		var dt_end = (this.enddate_enabled) ? cmonos.validate.datetime.getDateFromMenu('dt:ey','dt:em','dt:ed','dt:eh','dt:emin',date) : cmonos.validate.datetime.getDateFromMenu('dt:sy','dt:sm','dt:sd','dt:eh','dt:emin',date);
		var dt_end_time = dt_end.getTime();
		if (this.freq_enabled) {
			var dt_until = cmonos.validate.datetime.getDateFromMenu('dt:uy','dt:um','dt:ud');
			var dt_until_time = dt_until.getTime();
		}
		if (parseInt(dt_start_time/60000) >= parseInt(dt_end_time/60000)) {
			if (dt_type == 's') {
				dt_end_time = dt_start_time + this.se_gap;
				dt_end.setTime(dt_end_time);
				if (this.enddate_enabled) {
					cmonos.validate.datetime.setDateMenuByTime(dt_end,'dt:ey','dt:em','dt:ed','dt:eh','dt:emin',date);
				} else {
					cmonos.validate.datetime.setDateMenuByTime(dt_end,'dt:sy','dt:sm','dt:sd','dt:eh','dt:emin',date);
				}
			} else if (dt_type == 'e') {
				dt_start_time = dt_end_time - this.se_gap;
				dt_start.setTime(dt_start_time);
				cmonos.validate.datetime.setDateMenuByTime(dt_start,'dt:sy','dt:sm','dt:sd','dt:sh','dt:smin',date);
			}
		}
		this.se_gap = dt_end_time - dt_start_time;
		if (this.freq_enabled) {
			if (dt_end_time > dt_until_time) {
				if (this.eu_gap < 86400000) this.eu_gap = 86400000;
				dt_until_time = dt_end_time + this.eu_gap;
				dt_until.setTime(dt_until_time);
				cmonos.validate.datetime.setDateMenuByTime(dt_until,'dt:uy','dt:um','dt:ud');
			}
			this.eu_gap = dt_until_time - dt_end_time;
		}
		if (dt_type == 's') {
			cmonos.validate.datetime.setDateMenuByTime(dt_start,'dt:sy','dt:sm','dt:sd','dt:sh','dt:smin',date);
			if (this.freq_enabled) {
				var byday = new Array('dt-byday-su','dt-byday-mo','dt-byday-tu','dt-byday-we','dt-byday-th','dt-byday-fr','dt-byday-sa');
				document.getElementById(byday[dt_start.getDay()]).checked = true;
			}
		} else if (dt_type == 'e') {
			if (this.enddate_enabled) {
				cmonos.validate.datetime.setDateMenuByTime(dt_end,'dt:ey','dt:em','dt:ed','dt:eh','dt:emin',date);
			} else {
				cmonos.validate.datetime.setDateMenuByTime(dt_end,'dt:sy','dt:sm','dt:sd','dt:eh','dt:emin',date);
			}
		} else if (this.freq_enabled && dt_type == 'u') {
			cmonos.validate.datetime.setDateMenuByTime(dt_until,'dt:uy','dt:um','dt:ud');
		}
		if (this.freq_enabled) {
			this.setRRuleField();
			this.setRRuleTitle();
		} else if (document.getElementById('dt-span')) {
			document.getElementById('dt-span').innerHTML = this.getDateTimeSpan();
		}
	},

	setRRuleField : function () {
		if (!this.freq_enabled) return;
		var freq_options = document.getElementById('dt:freq').options;
		if (this.se_gap > 86400000) {
			var days = parseInt(this.se_gap / 86400000);
			if (freq_options.selectedIndex == 1 || freq_options.selectedIndex == 2) {
				freq_options[0].selected = true;
				this.setRRuleField("");
			}
			freq_options[1].disabled = true;
			freq_options[2].disabled = true;
			if (days > 28) {
				if (freq_options.selectedIndex == 3) {
					freq_options[0].selected = true;
					this.setRRuleField("");
				}
				freq_options[3].disabled = true;
				if (days > 364) {
					if (freq_options.selectedIndex == 4) {
						freq_options[0].selected = true;
						this.setRRuleField("");
					}
					freq_options[4].disabled = true;
				} else {
					freq_options[4].disabled = false;
				}
			} else {
				freq_options[3].disabled = false;
				freq_options[4].disabled = false;
			}
		} else {
			freq_options[1].disabled = false;
			freq_options[2].disabled = false;
			freq_options[3].disabled = false;
			freq_options[4].disabled = false;
		}
		var freq = cmonos.form.field('dt:freq').getValue();
		if (freq == "") {
			document.getElementById('dt-freq-settings').style.borderWidth = 0;
			document.getElementById('dt-rrule-title').innerHTML = "";
			document.getElementById('dt-rrule-settings').style.display = "none";
		} else {
			document.getElementById('dt-freq-settings').style.borderWidth = "1px";
			document.getElementById('dt-rrule-settings').style.display = "";
			document.getElementById('dt-byday-field').style.display = "none";
			document.getElementById('dt-by-field').style.display = "none";
			document.getElementById('dt-rrule-title').innerHTML = "";
			var interval_unit = document.getElementById('dt-interval-unit');
			if (freq == "daily") {
				interval_unit.innerHTML = '';
			} else if (freq == "weekly") {
				document.getElementById('dt-byday-field').style.display = "";
				interval_unit.innerHTML = '';
			} else if (freq == "monthly") {
				document.getElementById('dt-by-field').style.display = "";
				interval_unit.innerHTML = '';
			} else if (freq == "yearly") {
				interval_unit.innerHTML = 'ǯ';
			}
		}
		this.setRRuleTitle();
	},

	getDateTimeSpan : function () {
		return (parseInt(this.se_gap / 86400000) > 0) ? '(' + (parseInt(this.se_gap / 86400000) + (((this.se_gap % 86400000) > 0) ? 1 : 0)) + ')'
			: (parseInt(this.se_gap / 3600000) > 0) ? '(' + parseInt(this.se_gap / 3600000) + '' + parseInt((this.se_gap % 3600000) / 60000) + 'ʬ)' 
			: (parseInt(this.se_gap / 60000) > 0) ? '(' + parseInt(this.se_gap / 60000) + 'ʬ)' : '';
	},

	setRRuleTitle : function () {
		if (!this.freq_enabled) return;
		var freq = cmonos.form.field('dt:freq').getValue();
		var interval = parseInt(cmonos.form.field('dt:interval').getValue());
		var rrule_title = "";
		var espan = this.getDateTimeSpan();
		if (freq == "daily") {
			rrule_title = (interval == 1) ? '' : interval + '';
		} else if (freq == "weekly") {
			rrule_title = (interval == 1) ? '轵' : interval + '';
			var SU = (document.getElementById('dt-byday-su').checked) ? ' ' : "";
			var MO = (document.getElementById('dt-byday-mo').checked) ? ' ' : "";
			var TU = (document.getElementById('dt-byday-tu').checked) ? ' ' : "";
			var WE = (document.getElementById('dt-byday-we').checked) ? ' ' : "";
			var TH = (document.getElementById('dt-byday-th').checked) ? ' ' : "";
			var FR = (document.getElementById('dt-byday-fr').checked) ? ' ' : "";
			var SA = (document.getElementById('dt-byday-sa').checked) ? ' ' : "";
			if (interval == 1 && SU != "" && MO != "" && TU != "" && WE != "" && TH != "" && FR != "" && SA != "") {
				setOptionByValue(document.getElementById('dt:freq'),'daily');
				document.getElementById('dt-byday-field').style.display = "none";
				document.getElementById('dt-interval-unit').innerHTML = '';
				rrule_title = (interval == 1) ? '' : interval + '';
			} else if (SU == "" && MO == "" && TU == "" && WE == "" && TH == "" && FR == "" && SA == "") {
				this.fix('s');
			} else if (SU == "" && MO != "" && TU != "" && WE != "" && TH != "" && FR != "" && SA == "") {
				rrule_title += ' ʿ';
			} else {
				rrule_title += SU + MO + TU + WE + TH + FR + SA;
			}
		} else if (freq == "monthly") {
			rrule_title = (interval == 1) ? '' : interval + '';
			var dt_start = cmonos.validate.datetime.getDateFromMenu('dt:sy','dt:sm','dt:sd','dt:sh','dt:smin',document.getElementById('dt:date').checked);
			if (document.getElementById('dt-bywday').checked) {
				var week = new Array('','','','','','','');
				rrule_title += ' ' + (parseInt(dt_start.getDate() / 7) + ((dt_start.getDate() % 7 > 0) ? 1 : 0)) + week[dt_start.getDay()] + '';
			} else {
				document.getElementById('dt-bymday').checked = true;
				rrule_title += ' ' + dt_start.getDate() + '';
			}
		} else if (freq == "yearly") {
			rrule_title = (interval == 1) ? 'ǯ' : interval + 'ǯ';
		}
		if (rrule_title != "") rrule_title = '' + rrule_title + ''
		document.getElementById('dt-rrule-title').innerHTML = rrule_title + espan;
	},

	load : function () {
		this.freq_enabled = (document.getElementById('dt:freq')) ? true : false;
		this.enddate_enabled = (document.getElementById('dt:ey')) ? true : false;
		this.fix('s');
		if (this.freq_enabled) {
			this.setRRuleField();
			cmonos.element.item('dt-until-date').disappear(document.getElementById('dt:indefinite').checked);
			this.setRRuleTitle();
		}
	}
}